unit USEFUL;
{ Miscelaneous useful routines }

{Changes
   Dec 1998
     new ForEach
     new DoOver
     new TidyUpString
     new StealSubString
     new DoSQL
     new SQLCopyRecords
     new FlushTableBuffer
    edit SQLDate   - spaces added outside double quotes to avoid bondage & discipline

   Jan 1999
     new FlagDateValidity
    edit CheckTidyFloat - doesn't force 0 instead of blank
    edit LoadQueryBySQL ) - ignore "Invalid floating point operation" errors
    edit DoSQL          )   (appears to be select on date on empty table)
     new IsAValidDateString
     new NextHigherFilterString
     new PosPlus

   Feb 1999
     new ForceRounding
    edit DropZeros      - more effective method
    edit SQLCopyRecords - ) Big fix to use database.name not database.databasename
    edit DoSQL          - )
     new ToCSV
     new ToTSV
     new ServiceFinderLabel
     new Some nice colour constants

   Mar 1999
     new pCentralwrap
    edit pwrap          - -ve V indicates centrally print
     new posminus
    edit substr         - Bug fix (OOPS! must improve version control)
     new WinExecAndWait
     new DBBool
     new ClockWatch

   April 1999
      new TTinyDate               )
      new EncodeTinyDate          ) Encoding of dates between 1900 and 2100 in 3 characters
      new DecodeTinyDate          ) suitable for database use and also allows illegal values
      new EncodeSpecialTinyDate   ) for example "June 1997" ie unknown day
      new TTinyDateSpecialValue   )
      new TinyDateStr             )
      new TinyDNow                )
      new TextToTinyDate          )
-----------------------------------------------------------------------u/load
      new PrevOrNextDay           )
-----------------------------------------------------------------------u/load
      new TinyDatetoDateTime      )
      new DateTimeToTinyDate      )
      new TinyDateData            )
      new D2TD                    )
      new TD2D                    )
      new TDisReal                )
     edit **** All TinyDates changed to extend coverage ****
  removed TTinyDateSpecialValue   )
      new FormatTD                )
      new TinySQLDate             )

   May 1999
     edit NiceSmallDate       - Leading zero dropped from day
-----------------------------------------------------------------------u/load
      new SetCellPaintingParameters
     edit TextToTinyDate      - add ddmmyy format
     edit pwrap               - fix bug in centralisation
      new TinyDateInCell
     edit HowWideShouldThisDBGridBe
     edit TextToTinyDate
      new MonthStrToInt
      new RoundDecimal
      new GetNextChildNode
      new DoOverTree

   June 1999
      new ShowLabel
     edit TinyDateStr
     edit TextToTinyDate
      new CompareTD
      new TDLater
      new TDEarlier
      new foutputopen
      new finputopen
      new CrToCrLf

   July 1999
      new BlackOnWhite
      new WhiteOnBlack
      new StrToCurrency
      new InsRetDelEsc
-----------------------------------------------------------------------u/load
      new CurrencyData
      new Launch
  removed FlushTableBuffer
      new TagAndFlag
      new TagAndFlagAndHint
      new TagAndFlagValidate
      new TagAndFlagFocus1stProb
      new NicePounds
  removed PenceToSterling
  removed ForceRounding
  removed RoundDecimal
August 1999
      new LocateRelated
  changed Launch
      new CrossSet
      new SQLLoadStringList
      new Fixattwodecimals
      new Dropdown
     edit HowWideShouldThisDBGridBe
      new HowWideShouldThisGridBe
      new ReadCSVLine
      new pright
     edit incv
      new forceQueryReload
-----------------------------------------------------------------------u/load
      new DataModuleOpenClose
      new EditPostandFlush
      new TInteger
October 1999
  removed CommandPrinter  [commented out]
     edit ParseDate
     edit IsAValidDateString [based now on tiny date conventions]
      new GreyOut
      new ReadNBln
      new TTdate
      new tinyddmmyy
     edit Loadquerybysql  [allow null string to just do a reload]
-----------------------------------------------------------------------u/load
      new SQLLoadStringGrid
December 1999
      new CloseToBottomOfPage
      new Randomquote
     edit setfont            [-ve fontsizes treated as +ve]

January 2000
      new TstanpStr
      new (code snippet) Drop down combo box using F10
      new FullparseOfFileName

May 2000
     edit ReadIniFile     [smash case and lose all spaces is now optional]

June 2000
      new TestThisMutex
      new ReleaseAnotherCopyMutex
      new IsAnotherCopyRunning
     edit SqlCopyRecords  [Now use TBatchmove to allow batAppend without key viol]
     edit TextToTinyDate [2 digit year cut-off is now 95 years ago(floating)]
      new TDIsPrecise
      new isDriveReady
      new HomeDirectory

Oct 2000
      new SetFontOnAllForms
      new CfgFileName;

Dec 2000
      new SetField
      new UpdateField
     edit ReadIniSection  If a path supplied then don't force to executable path

Jan 2001
     edit ufilecopy     Uses Windows CopyFile() instead of custom buffer copy
      new PaintRectangle
     edit ReadIniSection  TidyUp now a set of flags not boolean
      new ReallyAssigned
      new WriteRegString
      new ReadRegString
---------------------------------------------------------------u/load
      new TidyFileName
          ReadIniDetail  (declaration put into interface section)
      new FreeListObjects

Mar 2001
      new ExtendForm

Apr 2001
     edit DoSQL     Bug fix
     edit SQLdate   Change date format

May 2001
     del Rtrim          Use TrimRight()
     del Ltrim          Use TrimLeft()
     del TrimString     Use Trim()

July 2001
     new RandomString
     new UniQueID

Aug  2001
    edit Pwrap    Allow vertical bars as CR and para
     new GetFileTimeStamp

Sept 2001
     new DoSQLqy
---------------------------------------------------------------u/load
Nov 2001
     new  GetExclusiveCounter
     new WritetoRichEdit

Dec 2001
     new StrLookup
     new DobToAgeStr
     new spacebuttons

Jan 2002
    edit foutputopen now returns false if fails
     new GetTempDirectory

Feb 2002
     new AlpahOrd
     new OrdAlpha
---------------------------------------------------------------u/load
Mar 2002
     new IntLookup
     new hhmmToMins
     new MinsTohhmm
    edit setfield (Updatefield) - Only does anything if data is changed
     new ComputerName

Dec 2002
     new SizeOfFile
     new SimpleHash

Jan 2003
     new LoadTextFile
     new SaveTextFile
     new StringToFont
     new FontToString
     new DrawComplexRotatedString
     new DrawGridFlag
     new DrawCircumferentialString
---------------------------------------------------------------u/load
     new DrawRadialText
     new chopback
overload WriteToRichEdit

Feb 2003
     new DrawFileIcon
Oct 2003
    edit SQLLoadStringList   - extra options added
---------------------------------------------------------------u/load
     new tinydmmmyy
     del OLD tiny dates
Nov 2003
     new NameOfUser
     new NameOfComputer
     new TdIsFuture
     new TdNowMinus

}


(**********************************************************************************
*******                                                                     *******
*******   LITTLE BITS OF CODE                                               *******
*******                                                                     *******
*******                                                                     *******
***********************************************************************************
  o Drop down combo box with F10 key
  o Put in OnKeydown event of a form
  o Set key preview = true
  -------------------------------//-----------------------------------------
  if (key = VK_F10) then begin
    if activecontrol is Tcombobox then begin
      with activecontrol as tcombobox do begin
        droppeddown := not droppeddown;
      end;
      key := 0;
    end;
  end;
  -------------------------------//-----------------------------------------

****************************************************************************)



interface

  uses
    registry,inifiles,classes,wintypes,winprocs,sysutils,dialogs,outline,
    forms,messages,shellapi,dbgrids,comctrls,math,windows,
    grids,printers,dbtables,stdctrls,controls,db,graphics,
    dbctrls,DbiTypes, DbiProcs, DbiErrs;

  type
  TDoOverFunct = Function(ds:TDataset):boolean;
  TForEachFunct = Function:boolean;
  TTreeLeafTestFunct = Function(n:TTreenode):boolean;

  TInteger  =  Class(TObject)
  { the purpose of this is to be able to add an integer to a list/stringlist etc
    as an object rather than trying to fool the system by casting it as a pointer
    Java programmers will know about this sort of thing}
    public
      value : Integer;
      constructor new(const i:integer);
  end;
  (*************************************************************
  ** Alternative to the above
  ** ------------------------
  **  This sort of thing gets programmers a bad name!
  **  No need to free the objects before clearing the list.
  **     add ... lb.items.addobject(somestring,pointer(aninteger));
  **     get ... aninteger := integer(objects[i]);
  *************************************************************)





  // used for various methods of tidying up ini files
  TTidyFlag = (tfLwrKey,tfNoSpaces,tfNoComments,tfTrimValue,tfOnlyEquals,tfNoBlanks);
  TTidyFlags = set of TTidyFlag;

  TTinyDate = String[3];    // encodes date in 3 chars and allows 'illegal' values
  TTinyTime = String[2];    // encodes time in 2 chars and allows illegal values

  TTDate = Class(TObject)
  { the purpose of this is to be able to add a tiny date to a list/stringlist etc
    as an object Java programmers will know about this sort of thing}
    public
      value : TTinyDate;
      constructor new(const d:TTinydate);
  end;


  (* TINY DATE
     A three character sortable,storable(as a three character string)
     date type.  The type is just a string -  all actions are performed by
     stand-alone functions.

     To show a date in a DBgrid do the following
     |  Drop DBGrid(G) ,DAtasource(DS) and Query(Q) onto a form.
     |  Q.sql is whatever you want when you want it
     |  DS.dataset := Q
     |  G.datasource := DS
     |  (at this point your data might show up but the date column will be
     |    hieroglyphics.)
     |
     |  Dbl-click on Q, add all fields, then create a new field.  (For the sake
     |  of this example we'll call the original date field DATE and now create
     |  a new one called TINYDATE).  This will be a string 9 characters long
     |  (longer if 4 digit dates are anticipated).  This is a calculated field.
     |
     |  In object inspector go to Q.OnCalcFields and add the following code:
     |    QTINYDATE.value := TinyDateStr(QDATE.value);
     |  (If Q was named Foo then this would look like
     |    FooTINYDATE.value := TinyDateStr(FooDATE.value);
     |
     |  Dbl-click on G to edit the columns list.  What you want to do now is to
     |  use the TINYDATE field not the DATE field.  (eg add all then delete DATE).


     Text read and write are customised for English style and English month names.


     Data format
     |  Bytes/Characters expressed left to right
     |
     |  0 1 y y y y y y
     |
     |  0 1 y y y m m m
     |
     |  0 1 m d d d d d
     |
     |  Strange layout is because (1)All high bits = 0 (2)No char can ever be all 0 bits
     |  Year offset = 1700
     |  Year = 0..500    0=No year    1=Not valid date  2=Beg.of.time  511= EndOfTime
     |  Month = 1..12    0=No month
     |  Day = 1..31      0=No day
     |
     *)

  ECantGetExclusiveCounter = Class(exception);


  TTinyDateSpecialValue =   //Result of DecodeTinyDate
      (tdCompleteDate,      //Years months and days specified
       tdYearOnly,          //Only year known
       tdYearMonthOnly,     //Year and month known but not days
       tdMonthOnly,         //Only month known
       tdMonthDayOnly,      //Only month and day valid
       tdBegOfTime,         //Beginning of time special value
       tdEndOfTime,         //End of time special value
       tdNotValid);


  TlbLoadOption =  //  LoadListBoxFromTable option ) How to set the
      (lbloFile,   //  Select current TABLE record ) LB selection
       lbloList,   //  Select current LIST record  )
       lbloNone);  //  Leave unselected

  TPrinterSettings =
      (psLandscape,psPortrait,
       psSimplex,PsDuplexShort,psDuplexLong,
       psUpper,psLower,psLargeCapacity,
       psPaperType1,psPaperType2,psPaperType3);


  TEDTFlag = (edtDate,edtTime,edtAllowBeforePresent,edtAllowWholeMonths,edtShortFormat,edtDaynames);
  TEDTFlags = set of TEDTFlag;

  TGridFlagtype = (stCircle,stSquare,stNone);

  // strings
  function chop(var Mainstring : string; const Chopper : string):string;
  function chopback(var Mainstring : string; const Chopper : string):string;
  function dequote(const S: string):string;
  function InDexOfString(S:String; A : Array of string):integer;
  function GetValue(const Slist:TStringList;key:string;var RHSide:string):boolean;
  //procedure Rtrim(var S:String);  use TrimRight()
  //procedure Ltrim(var S:String);  use TrimLeft()
  //Function TrimString(const S:String):String; use trim()
  function leftStr(const S:string; const L:integer) : String;
  function rightStr(const S:string; const L:integer) : String;
  function SubStr(const S:string; const ToBeRepl:string; const ReplBy:string):string;
  Function UnCapitalise(const S:String):string;
  Function StringToArray(const S,chopper:String;  var A : Array of string):integer;
  Function ArrayToString(const sep:string; const A :array of string):string;
  function ReadCSVLine(const s:string;var a:array of string):integer;
  Function DropZeros(const S:String):string;
  Function NicePounds(const v:currency; signs:boolean):string;
  Function SubStrip(const S,ToStrip,ToSub:string):string;
  function TidyUpString(const aString:String):string;
  Function StealSubString(var aString:String; const Choppers:string; var Stolen:string):boolean;
  Function NextHigherFilterString(const PartialKeyLow:string):string;
  Function PosPlus(const FirstChar:integer; const LookFor,Lookin:string):integer;
  Function PosMinus(const LookFor,Lookin:string):integer;
  function TidyFileName(const SomeString:string):string;
  function RandomString(const nocharstoreturn:integer):string;
  function SimpleHash(const srce:string):string;


  // printing
  //Function CommandPrinter(const Settings : Array of TPrinterSettings):Integer;
  procedure GetPrinterList;
  Function  SelectNamedPrinter(Const Pname:string):boolean;
  Function  CentralH(const Left,Right:integer;const S:string):integer;
  Function  CentralV(const Top,Bottom:integer; S:string):integer;
  Function  AlignBaseV(const VBaseLine:integer;S:string):integer;
  procedure pdecimal(const H,V:integer; DecimalString:string);
  procedure pright(const H,V:integer; aString:string);
  procedure pline(const H:integer; var V:integer; const S:string);
  procedure pout(const H,V:integer; S:string);
  procedure poutonline(const H,V:integer; S:string);
  procedure pwrap(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
  procedure pshrink(const H1,H2:integer; var V:integer; const S:string; const align:Talignment);
  Procedure pCentralWrap(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
  Function  TW(const S:string):integer;
  function  PX:integer;
  function  PY:integer;
  Function  pwrappingheight(const H1,H2:integer; const ToBeWrapped:string):integer;
  procedure _pwrapline(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
  procedure CanvasTextOutAngle(c: TCanvas; x,y: Integer; d: Word; s: string);
  procedure CanvasSetTextAngle(c: TCanvas; d: Word);
  procedure DrawComplexRotatedString(can: TCanvas; const originx,originy,radius,angle,twist:integer;str:string);
  procedure DrawCircumferentialString(can:tcanvas;const ox,oy,radius,Startang,Padding:integer;
                                                  const txt:string);
  procedure DrawRadialText(can:tcanvas;const ox,oy,radius,Startang,padding:integer;const txt:string);
  Procedure BlackOnWhite;
  Procedure WhiteOnBlack;
  Procedure WhiteOnGrey;
  procedure BlackOnGrey;
  procedure IncV(var V:integer; const S:string);
  function  pix(const mm:integer):integer;
  procedure setfont(const fName:string;fSize:integer);
  function  CloseToBottomOfPage(const BotMargInmm:integer):boolean;


  // message boxes
  function  mbox(const hand:Thandle;const Blurb,Title:string; Flags:word):Integer;
  function  ConfirmBox(const Blurb:string):boolean;
  procedure OKBox(const Blurb:string);
  procedure AlertBox(const Blurb:string);
  // NB See MessageDialogBx and CheckListBx units

  // misc utilities==============================================
  // misc file
  Function  FullparseOfFileName(const fname:string; var drive,path,name,ext:string):boolean;
  function  ExtendedFileexists(var fname:string; trypath:string):boolean;
  procedure uFileCopy(const FromFile, ToFile: string);
  procedure MakeBackupFile(const filename:string);
  function  ReadIniSection(var IniFileName:string;const SectName:string;
                        var SList:TStringList;const TidyUp:TTidyFlags) : boolean;
  Function  ReadIniDetail(const IniFile,Section,Key : string):string;
  //procedure delfile(const filename:string);
  function  foutputopen(var F:textfile;filename:string;new:boolean):boolean;
  function  finputopen(var F:textfile;filename:string):boolean;
  function  CrToCrLf(const filename:string):boolean;
  Function  Randomquote(const afilename:string):string;
  Function  GetFileTimeStamp(const fname:string):Tdatetime;
  function  GetTempDirectory:string;
  function  SizeOfFile(const fname:string):integer;
  function  LoadTextFile(const fname:string):string;
  procedure SaveTextFile(const fname,txt:string);


  // misc system
  Function  TestThisMutex(const IDString:string):THandle;
  Procedure ReleaseAnotherCopyMutex;
  Function  IsAnotherCopyRunning(const IDString:string):boolean;
  Function  ClockWatch(const TripTime:TDateTime; var Later:boolean):boolean;
  procedure Trap;
  procedure HourGlass(const puton:boolean);
  function  ProgramNameAndDate:String;
  function  HomeDirectory:string;
  function  WinExecAndWait(const FileName:String; const Visibility : integer):LongWord;
  function  isDriveReady(const drive:string) : boolean;
  procedure SetFontOnAllForms(const fName:String; fSize:Integer);
  Function  CfgFileName:string;
  function  ReallyAssigned(p:Tobject):boolean;
  procedure WriteRegString(const Root:HKEY;const PathKey,ValueKey,Value:string);
  function  ReadRegString(const Root:HKEY;const PathKey,ValueKey:string):string;
  function  ComputerName:string;
  procedure DrawFileIcon(const filename:string; can:tcanvas; const x,y:integer);
  //function  GetIconForFile(const filename:string):ticon;
  function NameOfUser:String;
  function NameOfComputer:String;



  // misc
  function Maximum(const A: array of variant):variant;
  function Minimum(const A: array of variant):variant;
  function StrToFloatDef(const S:string;const F:Extended):Extended;
  function StrToCurrency(const Str:string;var C:Currency):boolean;
  function ValidVariant(const V:Variant):boolean;
  function Twodecimals(const C:currency):currency;
  //function ForceRounding(const n:single):single;
  //function RoundDecimal(const n:single):single;
  function  ReadNBln(var f:TextFile;var s:string):boolean;
  function  ReadNBNQln(var f:TextFile;const remarkflag:string; var s:string):boolean;
  function  ToCSV(s:string):string;
  function  ToTSV(s:string):string;
  procedure FreeListObjects(L:Tlist);
  function  hhmmToMins(const hhmm:string):integer;
  function  MinsTohhmm(const mins:integer):string;
  procedure StringToFont(const s:string; var f:tfont);
  function  FontToString(const F:Tfont):string;



  // misc visual
  procedure ExtendForm(F:Tform);
  Function  Launch(ThisForm,aForm:TForm):TModalresult;
  procedure InsRetDelEsc(buIns,buRet,BuDel,BuEsc:Tbutton;var Key:Word);
  procedure GreyOut(eb:TControl;enable:boolean);
  procedure ShowLabel(alabel:Tlabel;const s:string);
  procedure TagAndFlagFocus1stProb(F:TForm);
  Procedure TagAndFlag(L:TLabel;Good:Boolean);
  Procedure TagAndFlagAndHint(L:TLabel;Good:Boolean;Hint:string);
  Function  TagAndFlagValidate(F:TForm;AControl:TWinControl):boolean;
  function  RectHeight( R:Trect) : integer;
  Function  RectWidth( R:Trect) : integer;
  function  Vscrollwidth:integer;
  function  MaxLineHeight(const C:Tcanvas):integer;
  procedure WrapIntoGridCell(Sender: TObject; C, R: integer;
            Rect: TRect; State: TGridDrawState);
  Function  MemoExtend(var aMemo:TMemo;MaxHeight:Integer):integer;
  Function  CheckTidyFloat(EB:TEdit):boolean;
  Procedure FlagEbGoodFloat(EB: TEdit; LA:TLabel; AllowZero:Boolean);
  Function  HowWideShouldThisDBGridBe(const G:TDBGrid):integer;
  Function  HowWideShouldThisGridBe(const G:TDrawGrid):integer;
  procedure Dropdown(CB:TComboBox);
  Function  ServiceFinderLabel(la : TLabel; var key:char;
                             const ForceUpperCase,CleanOddChars,FirstCapital:boolean):boolean;
  Procedure SetCellPaintingParameters(G:TDBGRID;State: TGridDrawState);
  Procedure TinyDateInCell(G:TDBGRID;const Rect: TRect;
                          datacol:integer; State:TGridDrawState);
  procedure PaintRectangle(const l,t,r,b,penwidth:integer; clr:Tcolor; canv:Tcanvas);
  procedure WriteToRichEdit(re:Trichedit; const s:string; fnt:tfont; newline:boolean); overload;
  procedure WritetoRichEdit(re:Trichedit; const s:string;
                            clr:tcolor; const fsize:integer;
                            bold,newline:boolean);                                     overload;
  procedure spacebuttons(buts : array of Tcontrol);
  procedure DrawGridFlag(can:tcanvas;const rect:trect;const Shape:TGridFlagtype;
                         const ShapeClr,TxtClr:tcolor;const text:string);


  // date routines********************************************************
  Function  ReadDate(Const DS:String; var DT:TDateTime):Boolean;
  Function  IsAValidDate(const yr,mo,dy:Word):boolean;
  Function  IsAValidDateString(const DS:string):boolean;
  Function  SQLDate(Const D:TdateTime):string;
  Function  BegOfTime:TDateTime;
  Function  EndOfTime:TDateTime;
  Function  NotAValidDate:TDatetime;
  Function  ExtractYear(const D:TDateTime):word;
  procedure DateKeyService(EB: TEdit; var Key: Char);
  Function  NiceSmallDate(const D:TDateTime):string;
  Function  ParseDate(const DS: String; var dy,mo,yr:word):boolean;
  Procedure FlagDateValidity(Const DS:String; DuffLabel:TLabel);
  function  MonthStrToInt(const Month:string):integer;
  Function  TstampStr(const DT:TDateTime):string;

  // tiny date routines  (q.v.constants and note above)****************
  // ==================================================================
  //function ConvertTD(B:TTinydate):TTinydate;
  //Function OLDEncodeTinyDate(const y,m,d:word):TTinyDate;
  //Function OLDDecodeTinyDate(const TinyDate:TTinyDate; var y,m,d:word):TTinyDateSpecialValue;
  Function EncodeTinyDate(const y,m,d:word):TTinyDate;
  Function DecodeTinyDate(const TinyDate:TTinyDate; var y,m,d:word):TTinyDateSpecialValue;
  Function TinyDateStr(const aDate:TTinyDate):string;
  Function TinyDNow:TTinyDate;
  Function TextToTinyDate(const DS:String):TTinyDate;
  Function ValidateDateStr(const ds:string;var day:ttinydate;const early,late:Ttinydate):boolean;
  Function PrevOrNextDay(const ADay:TTinyDate; const noOfDays:integer):TTinydate;
  Function DateTimeToTinyDate(const aDate:TdateTime):TTinydate;
(*  Function OLDTinyDatetoDateTime(const aDate:TTinyDate):TDateTime;
  Function OLDTinyDNow:TTinyDate;
  Function OLDTinyDateStr(const aDate:TTinyDate):string;*)
  Function TinyDatetoDateTime(const aDate:TTinyDate):TDateTime;
  Function TinySQLDate(Const D:TTinyDate):string;
  Function D2TD(const aDate:TDateTime):TTinyDate;
  Function TD2D(const aDate:TTinyDate):TDateTime;
  Function TDIsReal(const aDate:TTinyDate):boolean;
  Function FormatTD(const Format: string; aDate: TTinyDate): string;
  Function CompareTD(const FirstDate,SecondDate:TTinyDate):Integer;
  Function TDLater(const FirstDate,SecondDate:TTinyDate):Boolean;
  Function TDEarlier(const FirstDate,SecondDate:TTinyDate):Boolean;
  function tinyddmmyy(const d:TTinydate):string;
  function tinydmmmyy(const d:TTinydate):string;
  Function TDIsPrecise(const aDate:TTinyDate):boolean;
  Function TinyDaysDifference(const d1,d2:TTinydate):integer;
  function DobToAgeStr(const dob:TTinydate):string;
  Function TdIsFuture(const d:Ttinydate):boolean;
  Function TdNowMinus(const days:integer):ttinydate;




  // Outline
  Function nthChild(const OL:Toutline;const ParentIx,ChildNo:integer):Integer;
  procedure MakeNodeVisible(var OL:Toutline;IX:Integer);
  procedure SortOutline(var OL:Toutline;const ix:integer);
  // Tree
  Function DoOverTree(aNode:TTreenode;Funct:TTreeLeafTestFunct):integer;
  function GetNextChildNode(var TopNode,CurrentNode:TTreenode):boolean;

  // database *****************************************************************
  function  PathForAlias(const AName:string):string;
  procedure DataModuleOpenClose(DM:TDataModule;const Action:string);
  procedure forceQueryReload(Q:TQuery);
  procedure DoSQL(DB:Tdatabase; const S: string);
  procedure DoSQLqy(Qy:Tquery; const S: string);
  function  LoadQueryBySQL(var AQuery:Tquery; const S:string):integer;
  Function  WhereOrAnd(const SQL,Condition:string):string;
  function  SQLCount(var AQuery:Tquery; const S:string):integer;

  function SLData(const ADataSet:TDBDataset; Const AField:String; var SL:TStringList):Boolean;
  function IntData(const ADataSet:TDBDataset; Const AField:String):integer;
  function NullField(const ADataSet:TDBDataset; Const AField:String):boolean;
  function DateData(const ADataSet:TDBDataset; Const AField:String; var DateResult:TDatetime):Boolean;
  function TinyDateData(const ADataSet:TDBDataset; Const AField:String):TTinyDate;
  function StrData(const ADataSet:TDBDataset; Const AField:String):string;
  function SingleData(const ADataSet:TDBDataset; Const AField:String):Single;
  function DoubleData(const ADataSet:TDBDataset; Const AField:String):Double;
  function TFData(const ADataSet:TDBDataset; Const AField:String):boolean;
  function OneOfData(const ADataSet:TDBDataset; Const AField,TheOptions:String):integer;
  function CurrencyData(const ADataSet:TDBDataset; Const AField:String):Currency;
  function UniqueID(const ADataSet:TDBDataset; Const AField:String):string;

  procedure setfield(const ADataSet:TDBDataset; Const AField:String; NewData:variant);
  procedure Updatefield(const ADataSet:TDBDataset; Const AField:String; NewData:variant);
  procedure UpdateStrData(var ATable:TTable; Const AField,NewData:string;const EraseOnly:Boolean);
  procedure tDeActivate(aTable:TTable);
  procedure tActivate(aTable:TTable);
  function  TryEdit(aTable:TTable):boolean;
  function  TryPost(aDataset:TBdeDataset):boolean;
  Function  SQLCopyRecords(DestinationTbl:TTable; CopyMode: TBatchMode; const SQL:String;
                          SourceDatabase:TDatabase):integer;
  Function  DoOver(aDataset:TDataset;aFunction:TDoOverFunct):integer;
  Function  ForEach(aDataset:TDataset;aFunction:TForEachFunct):integer;
  Function  DBBool(const TF:Boolean):string;
  Function  LocateRelated(const FromTable:TTable; const FromField:string;
                          const LookupTable:TTable; const LookupField:string):boolean;
  Function  CrossSet(const DestTable:TTable;const DestField:string;
                     const SourceTable:TTable;const SourceField:string):boolean;

  Function  SQLLoadStringList(SL:TStrings; const SQL:string;
                            DB:TDatabase;const nastr:string; const trimmed:boolean):integer;

  Function  SQLLoadStringGrid(G:TStringGrid; const SQL:string;DB:TDatabase):integer;
  procedure EditPostandFlush(ATable:TTable;aFieldName:string;aValue:Variant);
  function  GetExclusiveCounter(exclTable,targetTable:Ttable):integer;
  function  StrLookup(const ADataSet:TDBDataset; Const KField,RField:String; const AKeyValue:variant):string;
  function  IntLookup(const ADataSet:TDBDataset; Const KField,RField:String; const AKeyValue:variant):Integer;
  function  AlphaOrd(const anOrdinal:integer):string;
  function  OrdAlpha(const aCharacter:string):integer;



var
  mmtopixel :single;
  WrapIsADummy : boolean;
  cascade : boolean;           // stopping cascading calls
  Printernames:TStringlist;
  LastQuote : string;          // save in case user wants another look
  AnotherCopyMutexHandle : THandle;   // mutex handle tests if another copy is running

const
  crlf : string[2]  = chr(13)+chr(10);
  lbloading : integer = 0;
  lbnotloading : integer = 1;

  // Standard constants used anywhere
  scSelect : integer = 0;  // set the tags on forms with grids in to
  scEdit : integer = 1;    // decide if ENTER calls edit or selects
  scValid : integer = 0;   // Set the tags on edit fields
  scNotValid : integer = 1;

  // database true/falses
  dbTrue : string = 'Y';
  dbFalse : string = 'N';
  dbUnknown : string = '?';

  // special date display strings
  NODATESTR    = 'No-Date';
  BEGOFTIMESTR = 'Beg-o-time';
  ENDOFTIMESTR = 'End-o-time';

  // special values when using numbers in db fields rather than timestamp+TdateTime
  EndOfTimeNumber = 4096.0;
  BegOfTimeNumber = 1.0;
  NotADateNumber  = 0.0;

  // TTinyDate special values
  OLDTDNVD = '!!!';      // not valid date
  OLDTDBOT = '!!"';      // Beginning of time
  OLDTDEOT = '!';      // End of time
  TDNVD = '@H@';      // not valid date
  TDBOT = '@P@';      // Beginning of time
  TDEOT = 'x@';      // End of time

  // TTinyTime special values
  TTNVT = '!!';       // not valid time


  // Used for testing maximum line heights
  // (This often gives a result that is larger than needed in practice)
  AY = 'y';

  // nice colours
  clBrick = 3166176;
  clOrange = 3170288;
  clOchre = 4239615;
  clMint = 9498640;
  clDeepBlue = 10489664;
  clSlate = 11570976;
  clRose = 12623871;
  clVividPurple = 14684096;
  clSky = 16752384;
  clDeepSky = 16744240;

implementation


procedure _pwrapline(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
{ private - wraps a single line without any formatting characters
  IF V is negative then centralise each line (but return a good V)}
var
  Charswide,ColWidth,PixPerChar : integer;
  WS,S,C: String;
  centralise : boolean;
Begin
  if (H1+10)>H2 then exit;  // trap silly/too narrow
  centralise := (V < 0);
  V := abs(V);
  with printer.canvas do begin
    // get some basic dimensional estimates
    S := 'nnnnnnnnnnn';       // get a rough guide to no of pixels per char
    pixperchar := textwidth(S) div length(S);
    ColWidth := (h2-h1)-1;                               // width
    Charswide := ColWidth div PixPerChar;                // est no characters in col
    if charswide < 2 then ColWidth := PixPerChar * 2;    // min col width of 2 characters
    WS := trim(ToBeWrapped);

    // get one line's worth at a time
    while WS<>'' do begin
      // chop a guess from the front of the text
      S := copy(WS,1,Charswide);
      if WS=S then WS:='' else WS:=copy(WS,CharsWide+1,9999);
      // could we add more to S?
      while WS <> '' do begin
        if textwidth(S)>=Colwidth then break;
        S := S + copy(WS,1,1);
        if length(WS)=1 then WS:='' else WS := copy(ws,2,9999);
      end;
      // should we take something away from the end of S because it is too long?
      while textwidth(S)>Colwidth do begin
        WS := copy(S,length(s),1)+WS;
        S := copy(s,1,length(s)-1);
      end;
      // at this point we know S will fit into the space allowed but
      // we may want to look for a more convenient
      // break point.
      if ws <> '' then begin
        while true do begin
          C := copy(S,length(s),1);
          if pos(C,' !%,?/:;-)')<>0 then break; // something good to end the line on
          ws := C+ws;
          S := copy(s,1,length(s)-1);
          if S = '' then begin              // trap when no breaks in text...
            S := copy(WS,1,Charswide);       // so guess a chop
            if WS=S then WS:='' else WS:=copy(WS,CharsWide+1,9999);
            break;
          end;
        end;
      end;
      // Now we have S as the string to print
      s := trim(s);
      if (not WrapIsADummy) then begin // print what we have got
        if not centralise then begin
          pline(H1,V,S);
        end else begin
          pline(centralh(H1,H2,S),V,S);
          (*@@@
          with printer.canvas do begin
            pen.width := 1;
            moveto(H1,V);
            lineto(H1,v-pix(5));
            moveto(H2,V);
            lineto(H2,v-pix(5));
            moveto(centralh(H1,H2,S),v);
            lineto(centralh(H1,H2,S),v-pix(5));
          end;*)
        end;
      end else begin
        // dummy so get line height
        V := V + textheight(S);
      end;
    end;
  end;
end;




procedure AlertBox(const Blurb:string);
{ pause with message.   Vertical bars in blurb act as CRLFs}
begin
  sysutils.beep;
  mbox(application.handle,Blurb,'Note',48);
end;




Function AlignBaseV(const VBaseLine:integer;S:string):integer;
{ return a vertical value so that the baseline of the text will print
  at the VBASELINE position}
begin
  result := Vbaseline - printer.canvas.textheight(S);
  // NB this is a crude method - one day we'll have to read the proper
  // font parameters
end;





Function BegOfTime:TDateTime;
{ return a date notionally representing the beginning of time}
begin
  result := encodedate(1,1,1);
end;




Procedure BlackOnWhite;
{ set the printer to print normally (black on white)
  automatically knock off any bold.
  See also WhiteOnBlack.
  (To avoid namespace conflict you may need to call with useful.BlackOnWhite) }
begin
  with printer.canvas do begin
    font.color := clblack;
    brush.color := clwhite;
    font.style := font.style - [fsbold];
  end;
end;




procedure CanvasSetTextAngle(c: TCanvas; d: Word);
{-----------------------------------------------------------
  PURPOSE
    To change the current text output rotation angle. All
    subsequent output will be at the angle provided.

  INPUT PARAMETERS
    c - The canvas on which to output the text. The font for
      the canvas must be a scaleable font.
    d - The angle in tenths of degrees. For example 10 would
      be 1 degree. 450 would be 45 degrees. 1 would be
      1/10 of a degree. To reset the text back to normal,
      make d = 0.

  HISTORY
    6/18/1995 First version written by Curtis Keisler.
-----------------------------------------------------------}
var
  LogRec: TLOGFONT;     {* Storage area for font information *}

begin
  {* Get the current font information. We only want to modify the angle *}
  GetObject(c.Font.Handle,SizeOf(LogRec),Addr(LogRec));

  {* Modify the angle. "The angle, in tenths of a degrees, between the base
     line of a character and the x-axis." (Windows API Help file.)*}
  LogRec.lfEscapement := d;
  LogRec.lfOrientation := d;

  {* Delphi will handle the deallocation of the old font handle and *}
  c.Font.Handle := CreateFontIndirect(LogRec);
end; {* CanvasSetTextAngle *}

{**********************************************************}




procedure CanvasTextOutAngle(c: TCanvas; x,y: Integer; d: Word; s: string);
{-----------------------------------------------------------
  PURPOSE
    To output rotated text in the same font as the font on
    the supplied canvas. The font must also be a scaleable
    font.

  INPUT PARAMETERS
    c - The canvas on which to output the text. The font for
      the canvas must be a scaleable font.

    x,y - The x,y screen coordinates you would normally
      supply the TextOut procedure.
    d - The angle in tenths of degrees. For example 10 would
      be 1 degree. 450 would be 45 degrees. 1 would be
      1/10 of a degree.
    s - The text to be output to the canvas.
  HISTORY
    6/18/1995 First version written by Curtis Keisler.
-----------------------------------------------------------}
var
  LogRec: TLOGFONT;     {* Storage area for font information *}
  OldFontHandle,        {* The old font handle *}
  NewFontHandle: HFONT; {* Temporary font handle *}

begin
  {* Get the current font information. We only want to modify the angle *}
  GetObject(c.Font.Handle, SizeOf(LogRec), Addr(LogRec));

  {* Modify the angle. "The angle, in tenths of a degrees, between the base
     line of a character and the x-axis." (Windows API Help file.)*}
  LogRec.lfEscapement := d;

  {* Create a new font handle using the modified old font handle *}
  NewFontHandle := CreateFontIndirect(LogRec);

  {* Save the old font handle! We have to put it back when we are done! *}
  OldFontHandle := SelectObject(c.Handle,NewFontHandle);

  {* Finally. Output the text! *}
  c.TextOut(x,y,s);

  {* Put the font back the way we found it! *}
  NewFontHandle := SelectObject(c.Handle,OldFontHandle);

  {* Delete the temporary (NewFontHandle) that we created *}
  DeleteObject(NewFontHandle);

end; {* CanvasTextOutAngle *}



procedure DrawComplexRotatedString(can: TCanvas; const originx,originy,radius,angle,twist:integer;str:string);
{ This draws text at an angle around an origin.  The sort of thing you might use
  when printing around the periphery of CD labels.

  originx,originy  : location of circle centre (pixels)
  radius           : length of radous (pixels)
                     if -ve thius moves the 0-degree point to the west
  angle            : tenth-degrees  (E=0 N=900 W=1800 S=2700)
  twist            : degrees  This twists the text.
                         -90  = Read text c/wise around periphery
                         +90  = Read text anti c/wise around periphery
                         +180 = Radial read down on left side of circle
  str              : text to print


  eg to draw the points of the compass with labels in varying orientations:-
    DrawComplexRotatedString(canvas,333,444,150,0,0,'East');
    DrawComplexRotatedString(canvas,333,444,150,900,0,'North');
    DrawComplexRotatedString(canvas,333,444,-150,0,0,'West');
    DrawComplexRotatedString(canvas,333,444,-150,900,0,'South');

  Note the Radius is the centre of the text being printed.  So for example
  "123456789" should print with "5" at the specified distance

  ---> See also DrawRadialText() for a paragraph of text to be printed in radial fashion
  ---> See also DrawCircumferentialString() for a string to be printed circimferentially


}
var
  s,c,z,alpha,beta,rad,degrees : double;
  cc,ss,ccc,sss,th,tw,deg : integer;
  ang : word;
begin

  // --- major angle ---
  degrees := angle / 10;
  rad := DegToRad(degrees);
  s := sin(rad);
  c := cos(rad);
  cc := round(c * radius);
  ss := round(s * radius);

  // --- minor twist ---
  th := can.textheight(str) div 2;
  tw := can.textwidth(str) div 2;

  deg := (360+round(degrees)+twist) mod 360;
  rad := DegToRad(deg);

  z := sqrt((th*th)+(tw*tw));
  alpha := arctan((th* 1.1) / (1.1*tw));
  beta := rad-alpha;
  s := sin(beta);
  c := cos(beta);
  sss := round(z * s);
  ccc := round(z * c);
  ang := deg * 10;
  CanvasTextOutAngle(can,(originx+cc-ccc),(originy+sss-ss),ang,str);
end;


procedure DrawCircumferentialString(can:tcanvas;const ox,oy,radius,Startang,padding:integer;
                                                const txt:string);
{ output circumferential text string.
  ox,oy    are origin
  radius   is (guess what!) radius
           ** NB if +ve this prints clockwise
                 if -ve this prints anti-clockwise
  StartAng is degrees times 10  (ie 345 is 34.5 degrees) measured anti-clock from 'east'
           ** NB anti-clock from West if radius is -ve
  Padding is an extra amount of space to put between characters (10 = double spacing)
  txt is text to print
}
var
  i,cw : integer;
  c : string;
  ang,deg,delta : Double;
begin
  ang := startang;
  for i := 1 to length(txt) do begin
    c := txt[i];
    cw := can.textwidth(c);
    delta := arctan((cw *500.1)/ (radius *1000.1));
    deg := radToDeg(delta);
    ang := ang - (deg*(10+padding));
    DrawComplexRotatedString(can,ox,oy,radius,trunc(ang),-90,c);
    ang := ang - (deg*(10+padding));
  end;
end;


procedure DrawRadialText(can:tcanvas;const ox,oy,radius,Startang,padding:integer;
                                                const txt:string);
var
  h,w : integer;
  s,t : string;
  reverse : integer;
  ang,delta,deg : double;
begin
  ang := startang;
  s := txt;
  if radius >=0 then reverse := 1 else reverse := -1;
  while s <> '' do begin
    t := trim(chop(s,'|'));
    if t = '' then h := can.textheight('x')
              else h := can.textheight(t[1]);

    delta := arctan((h *500.1)/ (radius *1000.1));
    deg := radToDeg(delta);
    if ang<>startang then ang := ang - (deg*(10+padding));   // 1st time don't shift on
    w := can.textwidth(t)*reverse;
    DrawComplexRotatedString(can,ox,oy,radius+(w div 2),trunc(ang),0,t);
    ang := ang - (deg*(10+padding));
  end;

end;




Function CentralH(const Left,Right:integer;const S:string):integer;
{ return a horiz value so that the string S will be printed centrally.
  Note: This will trim the string if it is too long.
  uses the current settings for Printer.canvas  fonts etc  }
var
  W : Integer;
  SS : String;
begin
  SS := S;
  W := Right-left;  // width
  if w < 10 then w := 10;
  while printer.canvas.textwidth(SS)>W do Ss := copy(SS,1,length(SS)-1);
  result := ((Left+Right)-printer.canvas.textwidth(SS)) div 2;
end;



Function CentralV(const Top,Bottom:integer; S:string):integer;
{ return a vertical value so that S will print vertically in the
  middle between the two }
begin
  result := ((Top+Bottom)-printer.canvas.textheight(S)) div 2;
end;




Function CheckTidyFloat(EB:TEdit):boolean;
{ 1) allow fractions (1/2,n/4,n/8,n/16) in the edit box text - convert to decimal
  2) report true if this is a valid float}
var
  s : string;
  i : integer;
begin
  result := true;
  if cascade then exit else cascade := true;    // cascade protect
  TRY
    s := trim(EB.text);
    if s = '' then begin
      s := '0';
      result := true;           // valid as a number
    end else begin
      // any fractions?
      i := pos('/',s);
      if i<>0 then begin
        if i <> length(s) then begin
          if pos('1/2',s)<>0 then begin
            s := substr(s,' 1/2','.5');
          end else begin
            if pos('/4',s)<>0 then begin
              s := substr(s,' 1/4','.25');
              s := substr(s,' 3/4','.75');
            end else begin
              if pos('/8',s)<>0 then begin
                s := substr(s,' 1/8','.125');
                s := substr(s,' 3/8','.375');
                s := substr(s,' 5/8','.625');
                s := substr(s,' 7/8','.875');
              end else begin
                s := substr(s,' 1/16','.0625');
                s := substr(s,' 3/16','.1875');
                s := substr(s,' 5/16','.3125');
                s := substr(s,' 7/16','.4375');
                s := substr(s,' 9/16','.5625');
                s := substr(s,' 11/16','.6875');
                s := substr(s,' 13/16','.8125');
                s := substr(s,' 15/16','.9375');
              end;
            end;{1/4}
          end;{1/2}
          s := substr(s,' .','.');
        end;
      end;{any fractions}
      result := (StrToFloatdef(s,-1)>=0)
    end;
  FINALLY
    if s <> eb.text then begin
      if not ((s='0') and (eb.text='')) then eb.text := s;
      eb.selstart := length(s);
    end;
    application.processmessages;
    cascade := false;
  END;
end;




function chop(var Mainstring : string; const Chopper : string):string;
{ RETURNS THE FRONT OF A STRING IDENTIFIED BY THE SEPARATOR chopper.
  THE MAINSTRING IS CLIPPED SO THAT ONLY THE BACK END REMAINS.
  * Mainstring = '' ==> result = ''
  * Chopper = ''    ==> result = mainstring, mainstring=''
  * Chopper itself is lost and may be multi-character

  NB This is destructive to Mainstring

  s := 'Foo(bar)baz';
  a := chop(s,'(');   // a=Foo, s=bar)baz
  b := chop(s,'ba')   // b='', s=r)baz
  c := chop(s,'ba')   // c=r) s=z
  d := chop(s,'ba')   // d=z  s=''

}

var
  silly:boolean;
  p : integer;
begin
  // trap exceptional cases
  silly := false;
  if Mainstring = '' then
    begin
      result := '';
      silly := true;
    end;
  if Chopper = '' then
    begin
      result := Mainstring;
      mainstring := '';
      silly := true;
    end;
  if silly then exit;

 p := pos(Chopper,Mainstring);
 if p = 0 then
   begin       {not found so return rest}
     result := Mainstring;
     mainstring := '';
   end
 else
   result := copy(Mainstring,1,p-1);    {return LH as function result}
   p := p + length(chopper);            {skip chopper}
   if p > length(Mainstring) then       {trap terminal chopper}
     Mainstring := ''
   else                                 {lose LH from main string}
     Mainstring := copy(Mainstring,p,length(mainstring)-(p-1));
end;


function chopback(var Mainstring : string; const Chopper : string):string;
{ RETURNS THE **BACK** OF A STRING IDENTIFIED BY THE SEPARATOR chopper.

  See chop() for details}
var
  ok,silly:boolean;
  i,j,p : integer;
begin
  // trap exceptional cases
  silly := false;
  if Mainstring = '' then begin
    result := '';
    silly := true;
  end;
  if Chopper = '' then begin
    result := Mainstring;
    mainstring := '';
    silly := true;
  end;
  if silly then exit;

  p := pos(Chopper,Mainstring);

  // easy case where there is no chopper so return the whole whack
  if p = 0 then begin       {not found so return rest}
    result := Mainstring;
    mainstring := '';
    exit;
  end;

  // do a character by character search back from the end
  ok := true;
  for i := length(mainstring)+1-length(chopper) downto 2 do begin
    ok := true;
    for j := 1 to length(chopper) do begin
      if mainstring[i+j-1] <> chopper[j] then begin
        ok := false;
        break;
      end;
    end;
    if ok then break;
  end;
  // if we get here then if OK is true we have found it and if not
  // it the place we're looking for must be 1 ('cos we know it is in there somewhere)
  if not ok then i := 1;

  result := copy(mainstring,i+length(chopper),99999);   // tail end returned
  if i = 1 then mainstring := ''
           else mainstring := copy(mainstring,1,i-1);

end;




Function ClockWatch(const TripTime:TDateTime; var Later:boolean):boolean;
{ The purpose of this function is to flag up true when we reach the
  specified time.  The function returns true when the later variable
  (which is used to keep state) goes from false to true.  It therefore
  only does this once per day.

  Example use:
    var
      TeaTime : TDateTime;
      TimeForTeaYet : Boolean;
    begin
      TeaTime := StrToTime('15:00');
      TimeForTeaYet := false;
      while Clockwatch(TeaTime,TimeForTeaYet) do begin
        ... //other things
      end;
      messagebox('Put the kettle on');
    end;

  Another way of implementing this would be to have the clockwatch
  routine within an OnTimer event and use globals.}
var
  NowLaterThanAlarm : Boolean;
begin
  application.processmessages;
  NowLaterThanAlarm := (frac(now) > frac(TripTime));
  if later then begin
    // possibility of going over midnight or
    // a first-time vague initialisation of the state variable
    result := false;              // never returns true
    later := NowLaterThanAlarm;   // possibly reset
  end else begin
    // we're looking for when LATER was false but is now true
    if NowLaterThanAlarm then begin
      Later := True;
      result := true;
    end else begin
      result := false;
    end;
  end;
end;



(*
Function CommandPrinter(const Settings : Array of TPrinterSettings):Integer;
{ Talk to the printer (driver) direct
  Return the pixels per inch

  psLandscape,psPortrait                  Orientation
  psSimplex
  PsDuplexShort,psDuplexLong              The edge speced is the binding edge
  psUpper,psLower,psLargeCapacity          Source bins specified explicitly
  psPaperType1 )   NT only
  psPaperType2 )   Not yet implemented
  psPaperType3 )}




var
  Device : array[0..1024] of char;
  Driver : array[0..1024] of char;
  Port : array[0..1024] of char;
  hDMode : THandle;
  PDMode : PDEVMODE;
  i,f,v : word;//integer;
begin
  FillChar(Device, SizeOf(Device), #0);
  FillChar(Driver, SizeOf(Driver), #0);
  FillChar(Port, SizeOf(Port), #0);

  result := 0;                                        // keep compiler quiet
  application.processmessages;
  Printer.PrinterIndex := Printer.PrinterIndex;       // don't know why this is here
  Printer.GetPrinter(Device, Driver, Port, hDMode);
  if hDMode <> 0 then begin
    pDMode := GlobalLock(hDMode);
    if pDMode <> nil then begin
      for i := low(Settings) to high(Settings) do begin
        case Settings[i] of
          psLandscape       :begin f := dm_Orientation; v := DMORIENT_Landscape; end;
          psPortrait        :begin f := dm_Orientation; v := DMORIENT_Portrait;end;
          psSimplex         :begin f := dm_Duplex; v:= DMDUP_SIMPLEX; end;
          PsDuplexShort     :begin f := dm_Duplex; v:= DMDUP_HORIZONTAL; end;
          psDuplexLong      :begin f := dm_Duplex; v:= DMDUP_VERTICAL; end;
          psUpper           :begin f := dm_DefaultSource; v:= DMBIN_UPPER; end;
          psLower           :begin f := dm_DefaultSource; v:= DMBIN_LOWER; end;
          psLargeCapacity   :begin f := dm_DefaultSource; v:= DMBIN_LARGECAPACITY; end;
        else
          v := 0;
          f := 0;
        end;
        if f <>0 then begin
          pDMode^.dmFields := pDMode^.dmFields or f;
          case f of
            dm_orientation   : pDMode^.dmOrientation :=v;
            dm_DefaultSource : pDMode^.dmDefaultSource := v;
            dm_Duplex        : pDMode^.dmDuplex := v;
          end;
        end;
      end;
      result := trunc((pDMode^.dmLogPixels)/25.4) ;
      // ****!!!*** this seems to always return 0 which is not what the book says
    end;
    GlobalUnlock(hDMode);
  end;
end;
*)


Function TdNowMinus(const days:integer):ttinydate;
{ return today's date less the given number of days }
begin
  result := prevornextday(Tinydnow,0-days);
end;

Function TdIsFuture(const d:Ttinydate):boolean;
{ return true if date is in the future }
begin
  result := (CompareTD(d,TinyDNow)>0);
end;

Function CompareTD(const FirstDate,SecondDate:TTinyDate):Integer;
{ Compare two tiny dates.
  Return <0 if First is DEFINITELY earlier than the second
  Return 0  if dates could refer to the same day (eg Jan '97 and 3rd Jan '97)
  Return >0 if First is DEFINITELY later than the second.

  Unsuitable comparisons (return 0):-
    if either is TDNVD
    if one has years but the other doesn't

  Examples
  TDBOT       TDBOT          0    (=)
  TDBOT       (any other)   -1    (any other except TDNVD)
  Jan 97      12 Jan 97      0    (could be the same day)
  1997        Feb 97         0    (could be the same)
  1997        1998          <0    (first is earlier without question)
  1997        1 Jan 98      <0    (first is earlier without question)
  1 Jan 98    1997          >0    (first is later without question)
  Mar 98      May            0    (unsuitable)
  Oct         Nov           <0    (first is earlier without question)
}
var
  d1,d2,m1,m2,y1,y2 : word;
  r1,r2 : TTinyDateSpecialValue;
  c1e,c1l,c2e,c2l : int64;  // day counts early & late
begin
  result := 0;      // default

  // get rid of sime very simple cases---------------------------------------
  if (firstdate=seconddate)
  or (firstdate=TDNVD)
  or (seconddate=TDNVD) then exit;      // result = 0

  // since they can't be equal we can knock off a few more simple cases
  if firstdate = TDBOT then result := -1;
  if seconddate = TDBOT then result := 1;
  if firstdate = TDEOT then result := 1;
  if seconddate = TDEOT then result := -1;
  if result <> 0 then exit;

  // nothing for it - we have to decode and fiddle
  r1 := DecodeTinyDate(FirstDate,y1,m1,d1);
  r2 := DecodeTinyDate(SecondDate,y2,m2,d2);
  if (r1=tdNotValid) or (r2=tdNotValid) then exit;   // =0

  // trap year dates mixing with non-year dates
  if r1 in [tdMonthOnly,tdMonthDayOnly] then begin
    if not (r2 in [tdMonthOnly,tdMonthDayOnly]) then exit;  // =0
  end;

  //  Calculate extreme possibilities of dates - in a crude day count
  // earliest dates (nb y/m/d values will be zero if not specified)
  c1e := (500*y1)+(32*m1)+d1;
  c2e := (500*y2)+(32*m2)+d2;
  // latest possible dates
  case r1 of
  tdYearOnly       : c1l := (500*y1)+(33*12)+31;   // 31st dec
  tdYearMonthOnly  : c1l := (500*y1)+(33*m1)+31;   // 31st
  tdMonthOnly      : c1l := (33*m1)+31;
  tdMonthDayOnly   : c1l := (33*m1)+d1;
  else
    c1l := c1e;
  end;{case}
  case r2 of
  tdYearOnly       : c2l := (500*y2)+(33*12)+31;   // 31st dec
  tdYearMonthOnly  : c2l := (500*y2)+(33*m2)+31;   // 31st
  tdMonthOnly      : c2l := (33*m2)+31;
  tdMonthDayOnly   : c2l := (33*m2)+d2;
  else
    c2l := c2e;
  end;{case}

  if c1l<c2e then result := -1;
  if c1e>c2l then result := 1;
  { otherwise dates could overlap --> 0}

end;




function ConfirmBox(const Blurb:string):boolean;
{ return true if confirmed.
  Vertical bars in blurb act as CRLFs}
begin
  result := (mbox(application.handle,Blurb,'Confirmation required',4+32)=6);
end;




Function CrossSet(const DestTable:TTable;const DestField:string;
                    const SourceTable:TTable;const SourceField:string):boolean;
{ This performs "Dest Table.Field := Source Table.Field"
  - Using current records
  - If destination dataset is not in edit/insert mode then put it in edit mode
  - Leave in edit/insert mode
  - Return false if a problem

  eg CrossSet(child,'Parent',parent,'ID'); // Stick parent's ID in child record
  }
begin
  result := DestTable.state in [dsEdit,dsInsert];
  if not result then result := tryedit(DestTable);
  if result then begin
    try
      desttable.fieldvalues[DestField] := Sourcetable.fieldvalues[SourceField];
    except
      result := false;
    end;
  end;
end;




function CrToCrLf(const filename:string):boolean;
{ converts a UNIX style file (lines end with LF) to
  a DOS style file as used by Delphi (lines end with CRLF)

  The original file is renamed to CRTOCRLF.TMP. (There are plenty
  of circumstances where the rename could fail but if you're using
  this you don't need to be remoinded of them - Just watch out and
  don't try anything silly late at night!)
}
var
  FromF, ToF: file;
  i,bsize : integer;
  NumRead, NumOut,NumWritten: Integer;
  Buf1: array[1..8000] of Char;
  Buf2: array[1..10000] of Char;
  last : integer;
const
  tempyfile = 'crtocrlf.tmp';
begin
  result := fileexists(filename);
  if not result then exit;
  if fileexists(tempyfile) then deletefile(tempyfile);
  result := renamefile(filename,tempyfile);
  if not result then exit;

  AssignFile(FromF, tempyfile);
  Reset(FromF, 1);		{ Record size = 1 }
  AssignFile(ToF, filename);	{ Open output file }
  Rewrite(ToF, 1);		{ Record size = 1 }
  bsize := sizeof(buf1);

  repeat
    BlockRead(FromF, Buf1, bSize, NumRead);
    if numread > 0 then begin
      numout:=0;
      last :=0;
      for i := 1 to numread do begin
        case ord(buf1[i]) of
        10 : begin
               if last <> 13 then begin
                 inc(numout);buf2[Numout]:=chr(13);
                 inc(numout);buf2[Numout]:=chr(10);
                 last := 10;
               end;
             end;
        13 : begin
               if last <> 10 then begin
                 inc(numout);buf2[Numout]:=chr(13);
                 inc(numout);buf2[Numout]:=chr(10);
                 last := 13;
               end;
             end;
        else
          inc(numout);
          buf2[Numout]:=buf1[i];
          last := 0;
        end;
      end;
      BlockWrite(ToF, Buf2, NumOut, NumWritten);
    end;
  until (NumRead <> bsize);

  System.CloseFile(FromF);
  System.CloseFile(ToF);
end;




function CurrencyData(const ADataSet:TDBDataset; Const AField:String):Currency;
{Read the current record in ADataset, indicated by AField
and return a currency.  This is a wrapper that traps
null variants being returned and converts into 0}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if (vartype(v) in [varsingle,vardouble,varcurrency]) then
    result := v
  else
    result := 0;
end;




Function D2TD(const aDate:TDateTime):TTinyDate;
{ shorthand for DateTimeToTinyDate function}
begin
  result := DateTimeToTinyDate(aDate);
end;




function DateData(const ADataSet:TDBDataset; Const AField:String; var DateResult:TDatetime):Boolean;
{Read the current record in ADataset, indicated by AField and return a date.
NOTE The function returns a boolean indicating is there a real date here
The DATE ITSELF is returned via the third argument}
var
  v : Variant;
begin
  result := true;
  v := ADataset.fieldvalues[AField];
  if vartype(v) = vardate then begin
    Dateresult := v;
    exit;
  end;

  if vartype(v) = varDouble then begin
    dateresult := v;
    result := true;
    exit;
  end;

  result := false;

end;




procedure DateKeyService(EB: TEdit; var Key: Char);
{ take the key provided and try to do something
  insert a call to this in the OnKeyPress event

  If the edit box text is a date then hitting "+"
  increases the date by one and "-" reduces it by one.
  "*" clears the date

  "." or enter go to the next item on the form.  The
  reason for this is so that clerks can use the
  numeric keypad for all their input.


  }
var
  t : string;
  d : Tdatetime;
  okdate : boolean;
begin
  t := EB.text;
  okdate := readdate(t,d);
  case pos(key,'*+-.'+chr(13)) of
  0 : ; // do nothing - key falls throught
  1 : begin     // clear
        EB.text := '';
        key := chr(0);
      end;
  2 : if okdate then begin     // increase date by one day
        d := d + 1;
        EB.text := nicesmalldate(d);
        key := chr(0);
      end;

  3 : if okdate then begin     // decrease date by one day
        d := d - 1;
        EB.text := nicesmalldate(d);
        key := chr(0);
      end;
  4,5 : begin
          with eb.owner as TForm do begin
            activecontrol := TWincontrol(components[eb.componentindex+1]);
            key := chr(0);
          end;
        end;
  end;

  application.processmessages;
end;




Function DateTimeToTinyDate(const aDate:TdateTime):TTinydate;
{ Convert a TDateTime value into a tTTinyDate }
var
  d,m,y : word;
begin
  if aDate = BegOfTime then begin
    result := TDBOT;
    exit;
  end;
  if aDate = EndOfTime then begin
    result := TDEOT;
    exit;
  end;
  if aDate = NotAValidDate then begin
    result := TDNVD;
    exit;
  end;

  try
    decodedate(aDate,y,m,d);
    result := encodetinydate(y,m,d);
  except
    result := TDNVD;
  end;
end;

(*
Function OLDDateTimeToTinyDate(const aDate:TdateTime):TTinydate;
{ ************ do not use **********
Convert a TDateTime value into a tTTinyDate }
var
  d,m,y : word;
begin
  if aDate = BegOfTime then begin
    result := OLDTDBOT;
    exit;
  end;
  if aDate = EndOfTime then begin
    result := OLDTDEOT;
    exit;
  end;
  if aDate = NotAValidDate then begin
    result := OLDTDNVD;
    exit;
  end;

  try
    decodedate(aDate,y,m,d);
    result := oldencodetinydate(y,m,d);
  except
    result := OLDTDNVD;
  end;
end;
*)


Function DBBool(const TF:Boolean):string;
{ return one of DBTRUE or DBFALSE depending on the argument}
begin
  if TF then result := DBTRUE else result := DBFALSE;
end;



function dequote(const S: string):string;
{ remove any surrounding double quotes then trim}
begin
  Result := trim(SubStr(S,'"',''));
end;




Function DoOver(aDataset:TDataset;aFunction:TDoOverFunct):integer;
{ Apply the function to all the records in the dataset in sequence
  Return the number of times the specified function returned true

  The function must take one argument of TDataset and return a boolean.
  The function has to be specified at the unit level (ie not a method)

  Example:
  |
  |// Define the function we'll be applying to the dataset
  |// ----------------------------------------------------
  |Function Foo(Tbl:TDataset):boolean;
  |begin
  |  with tbl do begin
  |    edit;
  |    fieldvalues['Timestamp'] := now;
  |    post;
  |    result := (fieldvalues['age']>10);
  |  end;
  |end;
  |
  |// Use function Foo on a table
  |// ---------------------------
  |Procedure Bar(aTable,TTable);
  |begin
  |  showmessage(inttostr(DoOver(aTable,Foo))+' records returned true');
  |end;      }

  // This is almost identical to FOREACH() but the function has an argument.}


begin
  result := 0;
  //Hourglass(true);
  with aDataset do begin
    first;
    while not eof do begin
      if aFunction(aDataset) then result := result + 1;
      next;
    end;
  end;
  //Hourglass(false);
end;




Function DoOverTree(aNode:TTreenode;Funct:TTreeLeafTestFunct):integer;
{ return the number of children(recursively) matching the specified boolean test
  obviously the function might include an action
  (but don't try fiddling with the treestructure!)

  EXAMPLE
  |  (Declare in interface section)
  |  Function NodeIsaLeaf(N:TTreenode):boolean;
  |
  |  (implement in implementation section.  NB a 'raw' function not "function Txxx.SomeFunction..."
  |  Function NodeIsaLeaf(N:TTreenode):boolean;
  |  begin
  |    result := not(N.HasChildren);
  |  end;
  |
  |  (use it to count how many child/grand child/gt.grand child etc items have no children)
  |  NumNoKids := DoOverTree(Atree.selected,NodeIsALeaf);


  Suppose you have a tree where selecting a leaf(no children) you want to process
  that particular item, but when a parent is selected then you want to process all
  the lowest level items in the same way in bulk then try something like this:
    N := ATree.selected;
    if N.haschildren then DoOverTree(N,ProcessNodeLeaf)
                     else ProcessNodeLeaf(N);
    (In this case ProcessNodeLeaf() will reach all children including those which
     have children themselves, so the first line of ProcessNodeLeaf() will be
     "if N.haschildren then exit;" ie do nothing.)
   }
var
  N : TTreenode;
  L : integer;
begin
  N := aNode;
  result := 0;
  with aNode.treeview do begin
    L := N.Level;
    while true do begin
      if Funct(N) then result := result + 1;
      if N.haschildren then begin   // go down a level?
        N := N.getFirstChild;
      end else begin
        while N.getNextSibling = nil do begin
          N := N.parent;                  // no siblings so go up a level
          if N.level = L then break;      // if arrived back at original level - DONE!
        end;
        if N.level = L then break;      // if arrived back at original level - DONE!
        N := N.getnextsibling;
      end;
    end;
  end;
end;


procedure DoSQLqy(Qy:Tquery; const S: string);
{ fancy version of execsql() }
begin
  with qy do begin
    sql.text := S;
    Hourglass(true);
    try
      execsql;
    except
      on e : Exception do begin
        // Invalid FP appears to be a bug in the BDE/SQL when selecting for dates on an empty table
        if e.message <> 'Invalid floating point operation' then begin
          alertbox('SQL CODE FAILED|('+e.message+')|'+s);
        end;
      end;
    end;
  end;
  HourGlass(false);   // this will also do application.processmessages
end;


procedure DoSQL(DB:Tdatabase; const S: string);
{ execute some sql that doesn't return a result set
  The query used to do this is ephemeral so there
  is never any bother about clashing with a tame
  ready-to-use query.  We need to know which
  database to point the query at though }
var
  q : Tquery;
begin
  q := Tquery.create(application);
  TRY
    q.databasename := DB.Databasename;
    DoSQLqy(q,s);
  FINALLY
    HourGlass(false);   // this will also do application.processmessages
    q.free;
  END;
  application.processmessages;
end;




procedure Dropdown(CB:TComboBox);
{ make the combo box drop down - typically put in OnEnter }
begin
  SendMessage(CB.handle, CB_SHOWDROPDOWN, Integer(True), 0);
end;


Function DropZeros(const S:String):string;
{ lose 0's if thats all there is after the decimal point }
begin
  result := trim(S);   // default = unchanged
  if pos('.',result) = 0 then exit;
  while rightstr(result,1)='0' do result:=copy(result,1,length(result)-1);
  if rightstr(result,1)='.' then result:=copy(result,1,length(result)-1);
end;





Function EndOfTime:TDateTime;
{ return a date notionally representing the end of time}
begin
  result := encodedate(4096,12,31);
end;



function ExtendedFileexists(var fname:string; trypath:string):boolean;
  {does the file exist?  If not then look in likely places before giving up.
    Look in trypath (if given being a std path format with ";" separation
    then look in the path of the currently executable.
    The FNAME argument is extended to the complete path if found}

  var
    fn : string;
    tp,p : string;
  begin
    result := true;
    if fileexists(fname) then exit;  {easy}

    {try the directory the program is located in}
    fn := extractfiledir(application.exename)+extractFilename(fname);
    if fileexists(fn) then begin
      fname := fn;
      exit;  {easy}
    end;

    {run through the path suggestions given in trypath}
    tp := trypath;
    result := false;
    while tp <> '' do begin
      p := chop(tp,';');                   {get next path in list to try}
      fn := p+'\'+extractFilename(fname);  {glue path and file name together}
      fn := substr(fn,'\\','\');                 {lose any duplicate slashes}
      if fileexists(fn) then begin
        fname := fn;
        result := true;
        break;  {while loop}
      end;
    end;
  end;{proc}




Function ExtractYear(const D:TDateTime):word;
{return the year portion of the date specified}
var
  yr,mo,dy:word;
begin
  decodedate(D,yr,mo,dy);
  result := yr;
end;




function finputopen(var F:textfile;filename:string):boolean;
{ try to open the file for input
  return false if file doesn't exist or otherwise can't be opened}
begin
  result := fileexists(filename);
  if result then begin
    try
      assignfile(F,filename);
      reset(F);
    except
      result := false;
    end;
  end;
end;




Procedure FlagDateValidity(Const DS:String; DuffLabel:TLabel);
{ if the date is not valid then show the label.
  Typically the label is a red X }
var
  yr,mo,dy : word;
begin
  DuffLabel.visible := not parsedate(DS,yr,mo,dy);
end;




Procedure FlagEbGoodFloat(EB: TEdit; LA:TLabel; AllowZero:Boolean);
{ Check if the edit box text is a valid number
  if so then hide the label
  otherwise show the label

  If AllowZero is false then a value of 0 is illegal also

  The label is typically a red X}
var
  ok : boolean;
  v : single;
begin
  ok := checktidyfloat(eb);
  if ok then begin
    if (not allowzero) then begin
      try
        v := strtofloat(eb.text)
      except
        v := 0;
      end;
      ok := (v <> 0);
    end;
  end;
  la.visible := not ok;
end;




Function ForEach(aDataset:TDataset;aFunction:TForEachFunct):integer;
{ Apply the function to all the records in the dataset in sequence
  Return the number of times the specified function returned true

  The function must take no arguments and return a boolean.
  The function has to be specified at the unit level (ie not a method)

  This is almost identical to DOOVER() but the function has no arguments.}

begin
  result := 0;
  with aDataset do begin
    first;
    while not eof do begin
      if aFunction then result := result + 1;
      next;
    end;
  end;
end;




Function FormatTD(const Format: string; aDate: TTinyDate): string;
{ FORMATDATETIME for Tiny date
  See also TinyDateStr
  If the date supplied is not real then default to
  the TinyDateStr representation
}
begin
  if TDisReal(aDate) then result := formatdatetime(format,TD2D(aDate))
                     else result := TinyDatestr(aDate);
end;




function foutputopen(var F:textfile;filename:string;new:boolean):boolean;
{ open text file for output
  if NEW is true then overwrite else append
  return false if an error during open
}
begin
  result := false;
  try
    assignfile(F,filename);
    if new then begin
      rewrite(F);
      result := true;
    end else begin
      try
        append(F);
        result := true;
      except
        try
          rewrite(F);
          result := true;
        except
          ;
        end;
      end;
    end;
  except
    result := false;
  end;
end;




function GetNextChildNode(var TopNode,CurrentNode:TTreenode):boolean;
{ returns true if we managed to get another child(recurse) for the specified node
  EXAMPLE
    ParentNode := aTree.selecetd;
    aNode := ParentNode;               // important
    while GetNextChildNode(Parent,aNode) do begin
      // do things with aNode here
    end;}
begin
  //if not assigned(CurrentNode) then Currentnode := TopNode;
  CurrentNode := CurrentNode.GetNext;
  if not assigned(CurrentNode) then result := false
                               else result := (CurrentNode.level > TopNode.level);
end;




function GetValue(const Slist:TStringList;key:string;var RHSide:string):boolean;
{Look up the key in the list provided.  This returns the rh side of the matched
 string in the parameter and returns FALSE if the key is not found.
 NB My convention is to have all keys in lowercase so if writing
 to such a list make sure that the keys are l/case!}
begin
  RHSide := Slist.values[lowercase(key)];
  result := (RHSide <> '');
end;




procedure HourGlass(const puton:boolean);
{ switch the hourglass on/off}
begin
  if puton then screen.cursor := crHourGlass else screen.cursor := crDefault;
  application.processmessages;
end;




Function HowWideShouldThisDBGridBe(const G:TDBGrid):integer;
{ calculate the ideal width for a TDBGRID }
var
  i,w,scroll : integer;
begin
  scroll := getsystemmetrics(sm_cxvscroll);
  with g do begin
    if borderstyle = bsNone then w := 0 else w := 2;
    if dgColLines in Options then w := w + columns.count - 1;
    if dgindicator in Options then w := w + scroll;
    for i := 0 to columns.count-1 do w := w + columns.items[i].width;
  end;
  w := w + scroll;
  result := w+2;
end;

Function HowWideShouldThisGridBe(const G:TDrawGrid):integer;
{ calculate the ideal width for a TstringGrid or TDrawgrid }
var
  i,w,scroll : integer;
begin
  scroll := getsystemmetrics(sm_cxvscroll);
  with g do begin
    if borderstyle = bsNone then w := 0 else w := 2;
    if goVertLine in Options then w := w + colcount - 1;
    for i := 0 to colcount-1 do w := w + colwidths[i];
  end;
  w := w + scroll;
  result := w+2;
end;



procedure IncV(var V:integer; const S:string);
{ increment the vertical printing position by the height of the string
  SPECIAL CASES
    if the string argument is null then use y as the basis
    if the string argument is "-" then DECREASE ie go back up a line  }
var
  i : integer;
  ss : string;
begin
  if ((s='-') or (s = '')) then ss := 'y' else ss := s;
  i := printer.canvas.textheight(ss);
  if s='-' then v := v - i else v := v + i;
end;




function IndexofString(S:String;A : Array of string):integer;
{return the index of the 1st string in the array following
  example  INDEXOFSTRING(month,['Jan','Feb','Mar'])  }
var
  i : integer;
begin
  result := 0;
  for i := Low(A) to High(A) do begin
    if comparetext(S,A[i])=0 then begin
      result := i;
      break;
    end;
  end;
end;




procedure InsRetDelEsc(buIns,buRet,BuDel,BuEsc:Tbutton;var Key:Word);
{ This traps the Ins,Return,Del and Esc keys and
  executes a click of the appropriate button.
  Typical use is in a keydown event of a grid performing a list function where
  we want to launch these functions.}
begin
  case key of
    VK_INSERT : begin
                  buIns.Click;
                  key := 0;
                end;
    VK_RETURN :  begin
                  buRet.Click;
                  key := 0;
                end;
    VK_DELETE : begin
                  buDel.Click;
                  key := 0;
                end;
    VK_ESCAPE : begin
                  buEsc.Click;
                  key := 0;
                end;
  end;{case}
end;




function IntData(const ADataSet:TDBDataset; Const AField:String):integer;
{Read the current record in ADataset, indicated by AField
and return an integer.  This is a wrapper that traps
null variants being returned and converts into 0}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if (vartype(v) in [varsmallint,varinteger]) then
    result := v
  else
    result := 0;

end;




Function IsAValidDate(const yr,mo,dy:Word):boolean;
{ Is this a valid date }
var
 y : word;
begin
  y := yr;
  if y = 0 then y := 1996;      // allow 0 for year leap year
  try
    encodedate(y,mo,dy);
    result := true;
  except
    result := false;
  end;
end;




Function IsAValidDateString(const DS:string):boolean;
{ true if this is a valid date string
  (Valid in the sense used by the tiny date routines ie with special values
  such as "T" for today)
  See TextToTinyDate for details}
begin
  result := TextToTinydate(DS)<>'';
end;




Function Launch(ThisForm,aForm:TForm):TModalresult;
{ utility to hide-showmodal-show
   ThisForm will always be the current form 'self'
   eg  Launch(self,anotherform);
}
begin
  ThisForm.hide;
  try
    result := aForm.showmodal;
  finally
    ThisForm.show;
  end;
end;




function LoadQueryBySQL(var AQuery:Tquery; const S:string):integer;
{ Load SPECIFIED query component using the supplied sql
  return the number of records found
  If S is a null string the just reload with what we have got already in the sql.text propery }
begin
  with AQuery do begin
    result := 0;
    if active then close;
    if s <> '' then sql.text := S;
    Hourglass(true);
    try
      open;
      result := recordcount;
    except
      on e : Exception do begin
        // Invalid FP appears to be a bug in the BDE/SQL when selecting for dates on an empty table
        if e.message <> 'Invalid floating point operation' then begin
          alertbox('SQL CODE FAILED|('+e.message+')|'+s);
        end;
      end;
    end;
  end;
  application.processmessages;
  HourGlass(false);   // this will also do application.processmessages
end;




Function LocateRelated(const FromTable:TTable; const FromField:string;
                         const LookupTable:TTable; const LookupField:string):boolean;
{ general purpose single field lookup.
  Locates value of FromTable.FromField in LookupTable indexed on Lookupfield.
  Return true if looked up record located.
  Example
    If not LocateRelated(Child,Parent,'ParentId','Id') then msgbx('Orphan!');}
var
  v : variant;
begin
  v := FromTable.Fieldvalues[FromField];               // get the key value
  result := (vartype(v)<>varNull);                     // real data?
  if result then begin
    with LookupTable do begin
      result := (fieldvalues[LookupField] = v);        // save doing a Locate() if we are already there
      if not result then begin
        result := locate(LookupField,v,[]);            // do the locate()
      end;
    end;
  end;
end;



procedure MakeBackupFile(const filename:string);
{ rename the specified file ...BAK
  deals with previous b/u versions
  and handles current not yet existing}
var
  ok : boolean;
  f : string;
begin
  ok := true;
  if fileexists(filename) then begin
    f := changefileext(filename,'.BAK');
    if fileexists(f) then ok := sysutils.deletefile(f);
    ok := ok and renamefile(Filename,f);
    if not ok then alertbox('Trouble making a backup for '+filename);
  end;
end;




procedure MakeNodeVisible(var OL:Toutline;IX:Integer);
{ IX is an index of an item in outline OL.  We want to expand
all its parents.  It appears delphi isnt very good at performing
expand so we have to do it ourselves.}
begin
  with OL do begin
    if not items[IX].isvisible then begin
      makeNodevisible(ol,items[IX].parent.index);
      items[IX].parent.expand;
    end;
  end;
end;




function Maximum(const A: array of variant):variant;
{Returns the largest item in the array
  eg aFloat := Maximum([1.111,2.222,anotherFloat,aninteger]);}
var
  i : integer;
begin
  result := A[low(a)];
  for i := high(A) downto 1 do
    if result < A[i] then result := A[i];
end;




function MaxLineHeight(const C:Tcanvas):integer;
{ what is the maximum height of text on this canvas at present?
   Does a textheight of "y"}
begin
  Result := C.textheight('y');
end;




function mbox(const hand:Thandle;const Blurb,Title:string; Flags:word):Integer;
{ ENCAPSULATION OF MESSAGEBOX FUNCTION
  THIS GIVES US A TITLE AND USES PLAIN STRINGS
  ALSO REPLACE VERTICAL BARS WITH CRLFs
  Icons:  i ... 64      ! ... 48       ? ... 32       Stop ... 16
  Buttons:  OK ... 0  Cancel+OK ... 1  Yes+No...4   Yes+No+Cancel...3
  Result:  OK...1   Cancel...2   Yes...6   No...7
}

var
  B:string;
  PB,PT: pchar;
begin
  B := Substr(Blurb,'|',crlf);
  getmem(PB,length(B)+1);
  strpcopy(PB,B);
  getmem(PT,length(Title)+1);
  strpcopy(PT,Title);
  mbox := messagebox(hand,PB,PT,Flags);
  freemem(PB,length(B)+1);
  freemem(PT,length(Title)+1);
end;




Function MemoExtend(var aMemo:TMemo;MaxHeight:Integer):integer;
{ call this in a memo.OnChange event handler
  if the bottom of the memo is to be extended
  downwards/upwards to adjust to the amount of text.
  return the height in pixels of the memo
  MaxHeight limits the extent in pixels}

var
  nolines : integer;
  memheight : integer;
  li : integer;
begin
    //never used/altered := false;

    // adjust target no of rows of text
    nolines := aMemo.lines.count;
    if nolines < 1 then begin
      nolines := 1;
    end else begin
      if aMemo.lines[nolines-1] = '' then inc(nolines);
    end;

    // calculate the target height
    // (strangely "Ay" rather "y" works best for line hight calcs)
    memheight := (Tform(aMemo.Owner).canvas.textheight(AY) * nolines);
    if memheight > MaxHeight then memHeight := MaxHeight;

    // possibly adjust
    if memheight <> aMemo.height then begin
      //never used/altered := true;
      aMemo.height := memheight;
      li := 0-aMemo.height;                {this is needed because the memo has a habit of}
      aMemo.perform(em_LineScroll, 0, li); {losing the top line so scroll up!!!}
    end;
    application.processmessages;
    result := memheight;

end;




function Minimum(const A: array of variant):variant;
{Returns the smallest item in the array
  eg aFloat := Maximum([1.111,2.222,anotherFloat,aninteger]);}
var
  i : integer;
begin
  result := A[low(a)];
  for i := high(A) downto 1 do
    if result > A[i] then result := A[i];
end;




function MonthStrToInt(const Month:string):integer;
{ try to convert the supplied string into a month number
  Digits are allowed as well as names 02,2 and even 0 or 00
  Names have to be distinct and are parsed from the front.  So
  for example "Fred" will return 2 (=February)
  A result of -1 indicates we couldn't interpret the month name }
var
  m : integer;
  mos : string;
begin
  if (length(month)<1) then begin
    result := -1;
    exit;
  end;
  mos := lowercase(Month);
  m := strtointdef(mos,99);
  if m > 12 then begin
    if (m = 99) then begin
      m := pos(mos[1],' f      sond');
      if m = 0 then begin
        m := pos(copy(mos+'?',1,2),'ja ap  au');
        if m = 0 then begin
          m := pos(copy(mos+'??',1,3),'mar ~~~ may jun jul');
          if m > 0 then m := (m + 11) div 4;
          if m = 0 then m := -1;
        end;
      end;
    end;
  end;
  result := m;
end;




Function NextHigherFilterString(const PartialKeyLow:string):string;
{ When filtering a table using the filter property there is no LIKE function.
  So to select items beginning with "ABC" we have to use something like
    (SomeField >= "ABC") and (Somefield < "ABD")
  This function returns the higher (in this case ABD) if provided with the lower eg (ABC)}
var
  c : char;
begin
  if length(PartialKeyLow)<1 then begin
    result := '';
  end else begin
    c := PartialKeyLow[length(PartialKeyLow)];
    c := succ(c);
    result := copy(PartialKeyLow,1,length(PartialKeyLow)-1)+c;
  end;
end;




Function NicePounds(const v:currency; signs:boolean):string;
{ return a string version of the currency value provided.
   Use ... format when more than (or = ) a pound and ...p when 99p or less
   If Poundsign is false then suppress the /p }
var
  s : string;
begin
  if v = 0 then begin
    result := '0.00';
  end else begin
    s := format('%m',[v]);
    if not signs then begin
      result := substr(s,'','');
    end else begin
      if abs(v)>=1 then begin
        result := s;
      end else begin
        result := substr(s+'p','','');
      end;
    end;
  end;
end;



Function NiceSmallDate(const D:TDateTime):string;
{ string representation of date in dd mmm yy format
  This is compatible with PARSEDATE()}
begin
  if D = NotAValidDate then result := NODATESTR
  else
   if D = BegOfTime then result := BEGOFTIMESTR
   else
    if D = EndOfTime then result := ENDOFTIMESTR
    else result := formatdatetime('d mmm yy',D);
end;




Function NotAValidDate:TDatetime;
{ return a value which we deem to be a non-date (actually 30 dec 1899) }
begin
  result := -700000;
end;




Function nthChild(const OL:Toutline;const ParentIx,ChildNo:integer):Integer;
{return the index of the nth child of the specified parent
 return -1 if ChildNo > no of children}
var
  i,c : integer;
begin
  if not OL.items[ParentIx].hasitems then begin
    Result := -1;  {fail on silly}
  end else begin
    c := ChildNo;                             {count down}
    i := OL.items[ParentIx].getfirstchild;    {ix of first child}
    c := c - 1;
    while c > 0 do begin
      i := OL.items[ParentIx].getnextchild(i);       {get the next child}
      if i = -1 then break;                   {but watch out for off the bottom}
      c := c - 1;                             {one less to do}
    end;
    result := i;
  end;
end;




function NullField(const ADataSet:TDBDataset; Const AField:String):boolean;
{ return true if the value of the field specified is null }
begin
   result := (vartype(ADataset.fieldvalues[AField]) in [VarEmpty,VarNull]);
end;




procedure OKBox(const Blurb:string);
{ pause with message.   Vertical bars in blurb act as CRLFs}
begin
  mbox(application.handle,Blurb,'Note',64);
end;




function OneOfData(const ADataSet:TDBDataset; Const AField,TheOptions:String):integer;
{ AFIELD (possibly) contains a single character.
  TheOptions is a set of characters we are testing against
  We return the position in these options *** starting at 1 ***
  eg
     case OneOfData(aTable,'TrafficLight','RAG') of   //red-amber-green
     ...
  This returns 0 if the field is empty or not one of the options.
  Case sensitive}
var
  s : string;
begin
  s := strdata(AdataSet,AField);
  result := 0;
  if s <> '' then result := pos(s,TheOptions);
end;




Function ParseDate(const DS: String; var dy,mo,yr:word):boolean;
{ convert the string to a date
  if ABLE TO PARSE then return true
  if YR is missing from string but >=0 when called then this is substituted 69->2069 70->1971
  if YR is missing from string but <0 then substitute current year

  RETURN FALSE IF ONE OF THE SPECIAL DATES eg "No-Date"  (CHANGED 10/10/99)

  Format of date string:
  1) Short string format
  -------------------------------------------
  <day><separator><month>[<separator><year>]
  where:
  <day> is one or two digits - allow leading zero
  <separator> is one of space,slash or minus
  <month> is one or two digits or a month name or abbreviated month name
  <year> (if present) is two or 4 digits.  If 2 digits then use the hundreds
    from the YR argument when initially called

  2) Compact numeric format
  -------------------------------------------
  Always six digits ddmmyy
}

var
  DT : TDateTime;
  a : array[0..8] of string;
  dasi,nof : integer;
  s : string;
begin
 {$WARNINGS OFF}
  DT := NotAValidDate;  // shut up compiler

  // Specials
  result := false;
  if (ds = NODATESTR) or (ds = BEGOFTIMESTR) or (ds = ENDOFTIMESTR) then exit;


  try
    decodedate(DT,Yr,mo,dy);
  except
    ; // ignore errors here
  end;
  {$WARNINGS ON}


  // can we treat this as a compact date of six digits?
  // --------------------------------------------------
  if length(ds)=6 then begin
    dasi := strtointdef(ds,0);
    if (dasi >= 10100) and (dasi <= 311299) then begin
      yr := dasi mod 100;
      dasi := (dasi - yr) div 100;
      mo := dasi mod 100;
      dasi := (dasi - mo) div 100;
      dy := dasi;
    end;
  end else begin
    // looks like we have a day number month name and year number
    // ----------------------------------------------------------
    // parse the string
    nof := Stringtoarray(DS,'-/ ',a);
    if nof < 2 then begin
      result := false;
      exit;
    end;

    // day
    dy := strtointdef(a[0],99);
    if (dy>31) then begin
      result := false;
      exit;
    end;

    // month
    s := copy(uppercase(a[1])+'  ',1,3);
    mo := strtointdef(trim(S),0);
    if mo =0 then begin      // looks like a month name
      if (s='JAN') or (S='JA ') then mo := 1 else
       if (s='FEB') or (S='FE ') then mo := 2 else
        if (s='MAR') or (S='MR ') then mo := 3 else
         if (s='APR') or (S='AP ') then mo := 4 else
          if (s='MAY') or (S='MY ') then mo := 5 else
           if (s='JUN') or (S='JE ') then mo := 6 else
            if (s='JUL') or (S='JY ') then mo := 7 else
             if (s='AUG') or (S='AU ') then mo := 8 else
              if (s='SEP') or (S='SE ') then mo := 9 else
               if (s='OCT') or (S='OC ') then mo := 10 else
                if (s='NOV') or (S='NO ') then mo := 11 else
                 if (s='DEC') or (S='DE ') then mo := 12;
    end;
    if (mo<1) or (mo>12) then begin
      result := false;
      exit;
    end;


    // 3 fields needed to have a chance of a date
    if nof >= 3 then begin
      yr := strtointdef(a[2],9999);
      if (yr = 9999) then begin
        result := false;
        exit;
      end;
    end;

  end;

  // we now have dy,mo and yr but yr might be two digits
  if yr < 100 then begin
    if yr < 57 then yr := yr + 2000 else yr := yr + 1900;
  end;


  // validate the date
  try
    //DT := encodedate(Yr,mo,dy);
    encodedate(Yr,mo,dy);
    result := true;
  except
    result := false;
  end;

end;




Procedure pCentralWrap(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
{ wrap the text but centralise as we go }
begin
  v := 0-v;
  pwrap(H1,H2,V,ToBeWrapped);
end;



procedure pright(const H,V:integer; aString:string);
{ print string right justified }
begin
  with printer.canvas do begin
    textout(H - textwidth(aString),V,aString);
  end;
end;

procedure pdecimal(const H,V:integer; DecimalString:string);
{ print a decimal number with the decimal point aligned at H
  S should contain a decimal point.  If not then it will be right justified to the point position}
var
  S : String;
  i : integer;
begin
  S := DecimalString;
  with printer.canvas do begin
    i := pos('.',S);                 // find the point
    if i > 0 then begin
      textout(H,V,copy(S,i,999));     // print the tail
      S := copy(S,1,i-1);
    end;
    i := H - textwidth(S);           // print the head
    textout(i,V,S);
  end;
end;




function pix(const mm:integer):integer;
{ convert mm to pixels
  NB assumes that the same printer is used throughout the program
  as the first time we use it we ask the printer to tell us -
  then it is stores for ready use

  SO IF YOU CHANGE PRINTERS USE A SPECIAL VERSION OF THIS FUNCTION
  TO FORCE A REFRESH OF THE CURRENT PRINTER PIXEL TO MM RATIO:
  CALL WITH A NEGATIVE ARGUMENT.

  eg 1st time you're printing a document after a possible printer
  (re)selection use X:=pix(0-Y) rather than X:=pix(Y)}
begin
  // first time get the info from the printer driver

  if ((mmtopixel < 1) or (mm<1)) then begin
    mmtopixel := getdevicecaps(Printer.handle,LOGPIXELSX)/25.4;
  end;
  result := trunc(mmtopixel * abs(mm));
end;




procedure pline(const H:integer; var V:integer; const S:string);
{ print out a string at the H and V pixel positions.
  increase V by the height of the text.
  See also POUT() }
begin
  with printer.canvas do begin
    textout(H,V,S);
    V := V + textheight(S);
  end;
end;





Function PosMinus(const LookFor,Lookin:string):integer;
{ like pos but searched from the back to the front}
var
  j : integer;
begin
  result := 0;
  if lookin = '' then exit;

  result := pos(Lookfor,Lookin);
  if result = 0 then exit;

  while result <> length(Lookin) do begin
    j := posplus(result+1,Lookfor,Lookin);
    if j = 0 then break;
    result := j;
  end;
end;




Function PosPlus(const FirstChar:integer; const LookFor,Lookin:string):integer;
{ this is an extension to the pos function.
  Start searching from the first character specified}
var
  fc,l,i: integer;
begin
  result := 0;
  fc := firstchar;
  if fc <= 1 then begin                 // start at beginning
    result := pos(Lookfor,Lookin);
    exit;
  end;
  l := length(lookin);
  if fc > l then exit;                  // start beyond end

  i := pos(Lookfor,copy(Lookin,fc,l));
  if i = 0 then exit;                   // not found

  result := fc + i -1;                  // adjust for offset
end;


{$WARNINGS OFF}




procedure pout(const H,V:integer; S:string);
{ print out a string at the H and V pixel positions.
  See also PLINE() }
begin
  with printer.canvas do begin
    textout(H,V,S);
  end;
end;




procedure poutonline(const H,V:integer; S:string);
{ textout function but with the V being the font base line not the top }
begin
  printer.canvas.textout(H,AlignBaseV(V,S),S);
end;


procedure pshrink(const H1,H2:integer; var V:integer; const S:string; const align:Talignment);
{ put the text between the Hs shrinking if necessary.
  Can be aligned TaLeftJustify,TaRightJustify,TaCenter }
var
  w,x : integer;
begin
  w := h2-h1;
  with printer.canvas do begin
    while textwidth(s)>w do begin
      font.size := font.size - 1;
      if font.size < 6 then break;
    end;
    case align of
    TaLeftJustify  : x := h1;
    TaRightjustify : x := h2 - textwidth(s);
    TaCenter       : x := h1 + ((w-textwidth(s)) div 2);
    end;{case}
    textout(x,v,s);
    v := v + textheight(s);
  end;
end;



Function PrevOrNextDay(const ADay:TTinyDate; const noOfDays:integer):TTinydate;
{ Use this to bump up or down the date by a number of days
  eg To get the previous day use (adate,-1) or a week in the future (adate,+7)
  return not-valid if ADAY is not a full and valid date}

var
  dy : integer;
  y,m,d : word;
begin
  if decodetinydate(aday,y,m,d) <> tdCompleteDate then begin
    result := TDNVD;
    exit;
  end;
  try
    dy := trunc(encodedate(y,m,d));
  except
    dy := 0;
  end;
  if dy = 0 then begin
    result := TDNVD;
    exit;
  end;
  dy := dy+NoOfDays;
  decodedate(dy+0.001,y,m,d);
  result := encodetinydate(y,m,d);
end;




function ProgramNameAndDate:String;
{ return the name of the EXE file and the file creation (i.e. compilation) time stamp}
var
 S,fs : String;
 ft : TDateTime;
begin
  s := application.exename;
  ft := GetFileTimeStamp(s);
  fs := formatdatetime('d-mmm-yy hh:nn',ft);
  result := S + '('+fs+')';
end;


Function GetFileTimeStamp(const fname:string):Tdatetime;
{ return the timestamp in TDateTime format
  if file not found then return NotAValidDate }
begin
  result := NotAValidDate;
  if not fileexists(fname) then exit;
  result := FileDateToDateTime(fileage(fname));
end;



procedure pwrap(const H1,H2:integer; var V:integer; const ToBeWrapped:string);
{ wrap the text within the limits H1 and H2
  Increase the Vertical position V to the next free line
  *** NB IF V is negative then centralise *** (Returns a +ve V correctly)
  Any "[..]" will result in a new line
  "[PARA]" will result in a new paragraph

  Additionally: use vertical bars as line breaks  1=CR 2=PARA

  See also PWRAPPINGHEIGHT()
  }
var
  T,S : String;
  centralise : boolean;
begin
  T := substr(ToBeWrapped,CRLF,' ');
  T := substr(T,'||','[PARA]');
  T := substr(T,'|','[..]');
  centralise := (V<0);
  // need to do tricks with text as we may have [PARA] and/or [NEWLINE] embeds
  while T <> '' do begin
    S := chop(T,'[');
    if centralise then v := 0-abs(v);
    _pwrapline(H1,H2,V,S);
    if T = '' then break;   // no remaining special commands
    S := chop(T,']');       // S<--command T<--remainder of text
    if pos('PARA',S)<>0 then V := V + pix(4);   // add some vertical white space
  end;
end;




Function pwrappingheight(const H1,H2:integer; const ToBeWrapped:string):integer;
{ return the height that would be used if the text was wrapped
  in these limits}
var
  V : Integer;
begin
  wrapisadummy := true;   // stop actual printing
  V := 0;
  pwrap(H1,H2,V,ToBeWrapped);
  wrapisadummy := false;
  result := V;
end;




function PX:integer;
{ printer position in pixels across page }
begin
  result := printer.canvas.penpos.X;
end;




function PY:integer;
{ printer position in pixels down page }
begin
  result := printer.canvas.penpos.Y;
end;




Function ReadDate(Const DS:String; var DT:TDateTime):Boolean;
{ Convert string to date. See PARSEDATE}
var
  dy,mo,yr : word;
begin
  // we might be using YR in PARSEDATE
  try
    decodedate(dt,yr,mo,dy);
  except
    decodedate(date,yr,mo,dy);
  end;
  // parse the date
  result := Parsedate(ds,dy,mo,yr);
  // convert parts into a TDateTime
  if result then  DT := encodedate(yr,mo,dy);
end;




Function ReadIniDetail(const IniFile,Section,Key : string):string;
{read a particular bit from the ini file}
var
 i : string;
 sl : TStringList;
begin
  i := inifile;
  sl := TStringList.create;
  try               {preoect against memory leak with SL}
     if readinisection(i,Section,sl,[]) then begin
       result := sl.values[key];
     end else begin
       result := '';
     end;
  finally
    sl.free;
  end;
end;{proc}



function ReadIniSection(var   IniFileName : string;
                        const SectName    : string;
                        var   SList       : TStringList;
                        const TidyUp      : TTidyFlags) : boolean;
{ read the ini file
  return true if successfull else false
  the whole section is in sList
  extract an element with Slist.values['key_string'] (built-in)
  or GetValue(slist,key,rhside)-->boolean (part of this module)
  //NO NO NO If result is false then slist will be nil

  If inifileName is given as '' then we'll try to use the name of the executable as a guide.
  If inifilename is not found then we'll look in the executable directory.
  if there is no path seperator in the infilename as given then use the executable path
  The ini file will be returned as a complete filename if found.

  TIDY UP
    TTidyFlag = (tfLwrKey,tfNoSpaces,tfNoComments,tfTrimValue,tfOnlyEquals,tfNoBlanks);
    TTidyFlags = set of TTidyFlag;

    tfLwrKey      = Convert key to lowercase
    tfNoSpaces    = Remove _all_ spaces
    tfNoComments  = Remove all comments (;....)
    tfTrimValue   = Remove only leading and trailing spaces from value string
    tfOnlyEquals  = Only return key=value lines
    tfNoBlanks    = Lose blank lines

}
var
  ini : TIniFile;
  x,s : string;
  i : integer;
begin

  {locate the file}
  {===============================================================================}
  if not fileexists(inifilename) then begin   {try the simple things first}
    if IniFileName = '' then begin            {use the exec name as basis of ini file}
      IniFileName := changefileext(application.exename,'.ini');
    end else begin                            {or just the path of the executable}
      if pos('\',inifilename)= 0 then begin
        IniFileName := extractfiledir(application.exename)+'\'+extractfilename(inifilename);
      end;
    end;
    if not fileexists(inifilename) then begin   {give up}
      mbox(application.handle,'File not found','Looking for the file|'+inifilename,48);
      result := false;
      exit;
    end;
  end;
  {inifiles need fully expanded names to work - shame about the documentation!}
  inifilename := expandfilename(inifilename);


  {create the TiniFile, load the list with data and destroy the Tinifile}
  {===============================================================================}


  ini := Tinifile.create(inifilename);
  try   {protect against memy leak}
    ini.readsectionvalues(SectName,Slist);
  finally
    ini.free;
  end;
  result := (slist.count > 0);
  if not result then begin
    //NO NO NO slist.free;  {fail if no strings loaded = section not found}
    exit;
  end;


  if tidyup = [] then exit;

  {tidy up all the strings we have been given}
  for i := 0 to slist.count -1 do begin
    s := slist.strings[i];
    // lose comments
    if tfNoComments in TidyUp then begin
      x := chop(s,';');
      s := x;
    end;
    if tfNoSpaces in TidyUp then begin
      x := substr(s,#8,'');
      s := substr(x,' ','');
    end;
    if pos('=',s)<>0 then begin
      x := trim(chop(s,'='));
      if tfLwrKey in TidyUp then x := lowercase(x);
      if tfTrimValue in TidyUp then s := trim(s);
      s := x+'='+s;
    end else begin
      if tfOnlyEquals in tidyUp then s := '';
    end;
    slist.strings[i] := s;
  end;
  // possibly remove null lines
  if ([tfOnlyEquals,tfNoBlanks] * Tidyup)<>[] then begin
    for i := slist.count-1 downto 0 do if slist.strings[i]='' then slist.delete(i);
  end;

end;{proc}




function RectHeight(R:Trect):integer;
{ height of a Rectangle }
begin
  RectHeight := 1+ R.bottom - R.top;
end;




Function RectWidth(R:Trect):integer;
{ width of a rectangle }
begin
  RectWidth := 1+ R.Right - R.Left;
end;



function leftStr(const S:string; const L:integer) : String;
{ return the left part of a string  L=0 is not an error }
begin
  if l<=0 then result := ''
          else result := copy(s,1,L);
end;

function rightStr(const S:string; const L:integer) : String;
{ RETURN THE RIGHT PART OF A STRING }
var
  i : integer;
begin
  if (S = '') or (L = 0) then
    rightstr := ''
  else
    begin
      i := length(S) + 1 - L;
      if i < 1 then i := 1;
      rightstr := copy(S,i,L);
    end;
end;



procedure GetPrinterList;
{ this is an attempt to circumvent the inability of Delphi to
  work with the list of printers on a mixed 95+NT network.

  Instead of Printers.printers the application will
   1) call this once during initialisation
   2) Look at PrinterNames (a TstringList)

  Obviously this means that the data is not live
  but this is much better than having the bloody
  thing crash and burn }
var
  i : integer;
begin
  if not assigned(PrinterNames) then Printernames := Tstringlist.create;
  printernames.clear;
  //SPS('GPL-1');
  with printer.printers do begin
    //SPS('GPL-2');
    for i := 0 to count-1 do PrinterNames.add(printer.printers[i]);
  end;
  //SPS('GPL-3');
end;

Function SelectNamedPrinter(Const Pname:string):boolean;
{ attempt to select a printer by name
  The name given only has to appear somewhere in the
  name of the printer
  return true if found and selected}
var
  i : integer;

begin
  // It is possible that Delphi can't handle a reported quirk in 95+NT where a mytery
  // printer neO: (?) is added momentarily to the list of printers.  Try to avoid this
  // by making our own copy;
  //SPS('SNP-1');

  if not assigned(Printernames) then GetPrinterlist;
  //SPS('SNP-2');

  result := false;
  with Printernames do begin
    for i := 0 to count-1 do begin
      if pos(uppercase(pname),uppercase(strings[i]))=1 then begin
        result := true;

        //   try to force some buggering about with printer
        //SPS('SNP-3');
        pix(-1);
        //SPS('SNP-4');
        application.processmessages;

        TRY
          //SPS('SNP-5('+pname+')');
          //printer.printerindex := i;                  //<--- CAUSES APPLICATION EXCEPTONS
          printer.printerindex := printer.printers.indexof(printernames[i]);

          //SPS('SNP-6');
        EXCEPT
          on e:exception do
            showmessage('PRINTER.PRINTERINDEX ERROR|('+e.message+')|PLEASE TELL PETER');

        END;

        break;
      end;
    end;
  end;
  //showmessage('Printer is now:'+printer.printers[printer.printerindex]);

end;




Function ServiceFinderLabel(la : TLabel; var key:char;
                             const ForceUpperCase,CleanOddChars,FirstCapital:boolean):boolean;
{ This is used to service a finder label
  The label shows what we're looking for in a query for example.
  You use this when you have a large list and when the user types in part of a key field
  the number of selected items reduces.   The finder label displays the current selection
  value. Backspace key is used to erase and will return true.


  Typically place this function in the OnKeyPress event of a grid and if it
  returns true then you have to reload the grid after reapplying your finding procedure.
  eg.  if ServiceFinderLabel(aLabel,key,true,true,false) then begin
         sql := 'select name from people where name like "'+aLabel.caption+'"'
         etc.


  LA              Label to change  (need not be visible)
  KEY             Key from OnKeyPress event arguments
                  If Key is used then it is returned as #0
  FORCEUPPERCASE  Force to uppercase
  CLEANODDCHARS   Ignore &, %, ', space and " (but consume the key)
  FIRSTCAPITAL    1st character is always capitalised
  Return TRUE if the label was changed
}
begin
  result := false;
  // backspace
  if (key = #8) then begin
    if la.caption <> '' then begin
      la.caption := copy(la.caption,1,length(la.caption)-1);
    end;
    key := #0;
    result := true;
    exit;
  end;

  // invalid keys
  if CleanOddChars then begin
    if pos(key,'&''"% ')<>0 then begin
      key := #0;
      sysutils.beep;
      exit;   // result = false
    end;
  end;

  if key >=#32 then begin        // ignore any control characters
    if (ForceUpperCase or (FirstCapital and (la.caption = ''))) then
     la.caption := la.caption + uppercase(key)
    else
     la.caption := la.caption + key;
    key := #0;
    result := true;
  end;

end;




Procedure SetCellPaintingParameters(G:TDBGRID;State: TGridDrawState);
{ adjust the pen colours according to the state of the grid }
begin
  with g.canvas do begin
    if gdSelected in state then begin
      pen.color := clHighlight;
      font.color := clHighlightText;
    end else begin
      pen.color := clWindow;
      font.color := clBlack;   // DON'T KNOW HOW TO REFERENCE A DEFAULT
    end;
  end;
end;




procedure setfont(const fName:string;fSize:integer);
{ quickly set the printer font

  A blank or 0 is no change for that parameter

  Fname can be a virtual font which means that if we get slightly
  different font names on a target operating system we can
  tweak the names (by hard coding) here.

  Also we can modify style throughout printing.
    <B> (in addition to) fname sets bold     ) Reset at next call
    <I> (in addition to) fname sets italic   ) without them

  Values: "*TIMES","*COURIER","*ARIAL","*SMALL","*HEADING"}

var
  fs : integer;
  bold,italic:boolean;
  fn : string;
begin
  // convert to working variables
  fn := fname;
  fs := abs(fsize);

  // bold or italic using html tag
  bold := (pos('<B>',fn)<>0);
  if bold then fn := substr(fn,'<B>','');
  italic := (pos('<I>',fn)<>0);
  if italic then fn := substr(fn,'<I>','');

  // some shortcuts and quick translations
  if fn = '*TINY' then begin fn := '*ARIAL' ; fs := 6; end;
  if fn = '*SMALL' then begin fn := '*ARIAL' ; fs := 8; end;
  if fn = '*HEADING' then begin fn := '*TIMES' ; fs := 18; end;
  if fn = '*TIMES' then fn := 'Times New Roman';
  if fn = '*ARIAL' then fn := 'Arial';
  if fn = '*COURIER' then fn := 'Courier New';

  // set the font
  with printer.canvas.font do begin
    // change name?
    if fn <> '' then begin
      if fn <> name then begin
        name := fn;
        if name <> fn then alertbox('Unable to change font to "'+fn+'"');
      end;
    end;

    // change size?
    if fsize = 0 then size := fs else size := fsize;

    // reset style normally but tweak if modifiers included
    style := [];
    if italic then style := style + [fsItalic];
    if bold then style := style + [fsBold];

  end;

end;




procedure ShowLabel(alabel:Tlabel;const s:string);
{ set the label caption and call application.processmessages
  (useful for 'in-progress' loop reporting }
begin
  alabel.caption := s;
  application.processmessages;
end;

(*function RoundDecimal(const n:single):single;
{ trap the naughty effects 1/3*3=0.99999999999 in floating points }
const
  F = 10000;
begin
  result := round(n*F)/F;
end; *)




function SingleData(const ADataSet:TDBDataset; Const AField:String):Single;
{Read the current record in ADataset, indicated by AField
and return a single.  This is a wrapper that traps
null variants being returned and converts into 0}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if (vartype(v) in [varsingle,vardouble]) then
    result := v
  else
    result := 0;
end;


function DoubleData(const ADataSet:TDBDataset; Const AField:String):Double;
{Read the current record in ADataset, indicated by AField
and return a double.  This is a wrapper that traps
null variants being returned and converts into 0}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if (vartype(v) in [varsingle,vardouble]) then
    result := v
  else
    result := 0;
end;




function SLData(const ADataSet:TDBDataset; Const AField:String; var SL:TStringList):Boolean;
{ read the current record in ADataSet
  Try to fill the string list with text from a memo field (could be a string)
  return false if there is no text

  NB it is quite OK and often simpler to use strdata() to access memo fields

  }
begin
  try
    SL.text := ADataset.fieldvalues[AField];
    result := true;
  except
    result := false;
  end;
  if result then result := length(SL.text)>0;
end;




procedure SortOutline(var OL:Toutline;const ix:integer);
{sort the immediate children of this item in the outline.
It might be a good to hide the outline before sorting}

var
  firstix,lastix,i,prv,childcount: integer;
begin
{method:
  We look to see if selected items need to be bumped up.
  We firstly select child 2 and compare with 1st then
  3rd with second which may trigger 2nd and 1st
  then 4th/3rd ... 3rd/2nd ...2nd/1st}
  if not OL.items[ix].hasitems then exit;   {silly}
  firstix := OL.items[ix].getfirstchild;
  if firstix = -1 then exit;                {odd but no first child}
  lastix := OL.items[ix].getlastchild;
  if firstix = lastix then exit;            {only one child}
  childcount := 1;
  while true do begin                       {loop, increasing last to look at}
    inc(childcount);
    i := nthChild(OL,IX,childcount);        {if beyond last child then i <- -1}
    if i = -1 then break;
    while i > firstix do begin              {i = ix of item we might bump up}
      prv := OL.items[ix].getprevchild(i);   {and it's previous mate}
      if prv < 1 then break;                {catch silly}
      if compareText(OL.items[i].text,OL.items[prv].text) < 0 then begin
        {swap}
        ol.beginupdate;
        OL.items[i].moveto(prv,oaInsert);
        ol.endupdate;
        i := prv;
      end else begin
        {no need to swap...since all lower are sorted we can quit}
        i := -1;  {flag quit}
      end;
    end;{inner loop bumping last item up until it settles in sorted position}
  end;{outer loop working our way down the children}
end;{proc}




Function SQLCopyRecords(DestinationTbl:TTable; CopyMode: TBatchMode; const SQL:String;
                        SourceDatabase:TDatabase):integer;
{ This is a bit like the TBatchMove and actually performs BatchMove
  What we're doing is hiding the query used as the intermediate stage
  Also we're assuming that the records are the same format

  See BatchMove for details of CopyMode argument
  SQL is a select statement applied to the SourceDatabase

  example:
    if SQLCopyRecords(OneTable,batAppend,s,DBLive) = 0 then showmessage(S + 'Copied no records')

  Extensions:
    If a SQL of "select * from mytable..." is used then this copies the selected
    records but does not delete them from the source table.  However since we often
    want to _move_ the records the "SQL" syntax is allowed to be modified:-
      COPY mytable where ...          )  Duplicate
      mytable where ...               )  the selected records
      select * from mytable where ... )  All three syntaxes are equivilent
      MOVE mytable where ...             COPY then (if successfull) DELETE from source

   Shortcut: Since every SQL will start "select * from ..." this can be ommitted }
var
  mode,s,sdelete : string;
  q : TQuery;
  b : Tbatchmove;
begin
  result := 0;
  q := TQuery.create(application);
  b := TBatchMove.create(application);
  s := sql;

  mode := 'copy';
  if copy(lowercase(s),1,4)='copy' then begin
    s := copy(s,5,999);
    s := substr(s,' from ',' ');
    s := substr(s,'* from',' ');
  end else begin
    if copy(lowercase(s),1,4)='move' then begin
      s := copy(s,5,999);
      s := substr(s,' from ',' ');
      s := substr(s,'* from',' ');
      sdelete := 'delete from '+s;
      mode := 'move';
    end;
  end;

  if copy(lowercase(s),1,6)<>'select' then s := 'select * from ' + s;

  TRY
    try
      q.databasename := SourceDatabase.Name;
      result := Loadquerybysql(q,S);
      if result > 0 then begin
        // something to do so ensure we can get to the destination table
        if not DestinationTbl.active then DestinationTbl.open;
        application.processmessages;

        // set up and execute the TBatchMove
        // (we can't use the batchmove method of TTable because of the AbortOnKeyViol property)
        with b do begin
          source := q;
          destination := DestinationTbl;
          mode := CopyMode;
          AbortOnKeyViol := false;

          execute;
          result := movedcount;
          DestinationTbl.refresh;
        end;

      end;
    except
      on e : Exception do
        alertbox('ERROR|SQLCopyRecordsFailed|Dest='+DestinationTbl.TableName+'|SQL='
                +s+'|Database='+Sourcedatabase.name
                +'|'+e.message);
    end;

    // we have finished oif just duplicating but we might
    // want to delete the original as well
    if (result > 0) and (mode='move') then DoSQL(sourcedatabase,sdelete);

  FINALLY
    q.free;
    b.free;
  END;
end;

function SQLCount(var AQuery:Tquery; const S:string):integer;
{ this executes a sql query which is in the form of
  SELECT COUNT(xxx) FROM ... (or SUM,MIN,MAX or AVG etc)
  The single value is then returned

  NB.  If you want (say) an average which is not an integer
  then fields[0] of the query holds the result you want.
  So you would use code like
    SQLCount(MyQy,'select sum(payments) from invoice');
    TotalPayments := MyQy.fields[0].asfloat;
  }
var
  ok : boolean;
begin
  result := 0;

  // simple input arg checks
  ok := pos('COUNT(',uppercase(s))<>0;
  if not ok then ok := pos('SUM(',uppercase(s))<>0;
  if not ok then ok := pos('AVG(',uppercase(s))<>0;
  if not ok then ok := pos('MIN(',uppercase(s))<>0;
  if not ok then ok := pos('MAX(',uppercase(s))<>0;
  if not OK then begin
    alertbox('SQLCOUNT ERROR|Not an aggregate query');
    exit;
  end;

  // execute the query and check we only have one row returned
  if loadquerybysql(AQuery,S) <> 1 then begin
    alertbox('SQLCOUNT ERROR|More than one row returned');
    exit;
  end;

  try
    result := aquery.fields[0].asinteger;
  except
    alertbox('SQLCOUNT ERROR|Odd result type');
  end;

end;




Function SQLDate(Const D:TdateTime):string;
{ format the date so that it is acceptable as an input argument in a SQL query
  Warning : SQL date formats can vary.
}
begin
  //result := ' "'+ uppercase(formatdatetime('dd"-"mmm"-"yyyy',D))+'" ';
  result := ' "'+ uppercase(formatdatetime('dd"."mm"."yyyy',D))+'" ';
end;


Function SQLLoadStringGrid(G:TStringGrid; const SQL:string;DB:TDatabase):integer;
{ load the specified string grid with the fields returned by the query}
var
  Q : TQuery;
  S : string;
  r,i : integer;
begin
  Q := TQuery.create(nil);
  Q.databasename := DB.databasename;
  TRY
    result := loadquerybysql(Q,SQL);
    if result>0 then begin
      G.colcount := Q.fields.count;
      G.rowcount := result+1;
      r := 0;
      with Q do begin
        first;
        while not eof do begin
          inc(r);
          for i := 0 to fields.count-1 do begin
            s := fields[i].displaytext;
            if (fields[i].datatype = ftstring) then begin
              if length(s)=3 then begin
                s := Tinydatestr(s);
              end;
            end;
            g.cells[i,r] := s;
          end;
          next;
        end;
      end;
    end;
  FINALLY
    Q.free;
  END;
end;



Function SQLLoadStringList(SL:TStrings; const SQL:string;
                           DB:TDatabase;const nastr:string; const trimmed:boolean):integer;
{ load the specified string list with the fields returned by the query
    if nastr <> '' then insert it at the top of the list  eg <not applicable>
    if trimmed is true the trim spaces.  (Otherwise fixed width padding)
}
var
  Q : TQuery;
  S : string;
  i : integer;
begin
  Q := TQuery.create(nil);
  Q.databasename := DB.databasename;
  SL.clear;
  if nastr<>'' then SL.add(NaStr);           // 'not applicable string at top
  TRY
    result := loadquerybysql(Q,SQL);
    if result>0 then begin
      with Q do begin
        first;
        while not eof do begin
          s := '';
          for i := 0 to fields.count-1 do begin
            S := S + copy(fields[i].displaytext+'                           ',
                          1,
                          fields[i].displaywidth);
          end;
          if trimmed then s := trim(s);
          SL.add(S);
          next;
        end;
      end;
    end;
  FINALLY
    Q.free;
  END;
end;




Function StealSubString(var aString:String; const Choppers:string; var Stolen:string):boolean;
{ extract a substring delimited by the 'choppers' return true if found
  if the choppers found with nothing in then then return false but still
  remove the choppers.
  examples:
     astring        Choppers    ---->  Result  astring     Stolen
     -------        --------           ------  -------     ------
     abc(def)       ()                 True    abc         def
     abc()pqr       ()                 False   abcpqr      ''
     pqr/stu/xyz    //                 True    pqrxyz      stu
     pqr[99]        //                 False   pqr[99]     ''
     a(b)c(d)       ()                 True    ac(d)       b
     a(b(c)d)       ()                 True    ad          b(c    <--WATCH THIS CASE
  Choppers is always two characters}
var
  o,c : integer;
begin
  result := false;
  if length(choppers)<>2 then exit;
  o := pos(copy(choppers,1,1),astring);
  if (o = 0) or (o=length(astring)) then exit;         // nothing to do
  stolen := copy(astring,o+1,9999);
  c := pos(copy(choppers,2,1),stolen);
  if c = 0 then begin                                  // closer not found
    stolen := '';
    exit;
  end;
  stolen := copy(stolen,c-1,9999);                     // one of our results
  delete(astring,o,length(stolen)+2);                  // extract from original
  result := (length(stolen)>0);                        // and report success
end;




function StrData(const ADataSet:TDBDataset; Const AField:String):string;
{Read the current record in ADataset, indicated by AField
and return a string.  This is a wrapper that traps
null variants being returned and converts into ''}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if vartype(v) = varNull then
    result := ''
  else
    result := v;
end;




Function StringToArray(const S,chopper:String;  var A : Array of string):integer;
{ split the string into words as defined by the characters in chopper
  return the number of strings in the array
  return -ve if busted string array limit

  example:  nofields := StringToArray(CSVSTRING,'",',flds);

  NB see READCSVLINE for reading CSV data

  Important note: Because this routine takes consecutive chopper characters
  to mean nothing else to do null entries can get lost.  Therefore
  in the case of CSV files it is prudent to convert "" to " " before
  calling so that all fields are counted.  }
var
  c : string;
  ns,i : integer;
begin
  result := 0;
  if S = '' then exit;       // nothing in the string
  if chopper='' then begin   // silly no chopper characters
    result := -1;
    a[low(a)] := S;
    exit;
  end;

  ns := low(a);
  a[ns]:= '';
  for i := 1 to length(s) do begin
    c := copy(S,i,1);
    if pos(c,chopper)<>0 then begin
      if a[ns]<>'' then begin        // marks the end of something previous
        inc(ns);
        if ns > high(a) then begin   // trap busted array bounds
          result := 0-(ns-1);
          break;
        end;
        result := ns;
        a[ns]:='';                   // clear next array element
      end;
    end else begin
      a[ns]:= a[ns]+c;
    end;
  end;
  // special case where last thing read was a chopper character
  if result > 0 then begin
    if a[result] = '' then result := result - 1;
  end;

  // return the NUMBER of strings which is 1 more than HIGHEST used
  if result > -1 then  result := result + 1;
end;




function StrToCurrency(const Str:string;var C:Currency):boolean;
{ convert string to currency
  NB The function result is boolean (OK or not) while the
  Currency value we want is one of the args
  A null string "" returns false and 0
  A zero        "0" returns true and 0
  A problem string returns
    false and -1 if unknown why
    false and -2 if  and p both appear
    false and -3 if space appears in middle of figures

  Special formatting rules.  All amounts are supposed to be in  unless
  the last character is "p" and there is no decimal point

  123.45   --> 123.45
  123.45    --> 123.45
  123       --> 123
  123p      --> 1.23
  12.3p     --> 0.123
  1.23p     --> 0.0123
  }
var
  s,t,a : string;
  i : integer;
  pence : boolean;
begin
  s := trim(str);
  c := 0;

  // special case for pence
  pence := rightstr(s,1)='p';
  if pence then begin
    if pos('',s)<>0 then begin   // trap conflicting 
      result := false;
      C := -2;
      exit;
    end;
  end;

  // drop all currency characters etc
  t := '';
  for i := 1 to length(s) do begin
    a := s[i];
    if a = ' ' then begin
      result := false;
      C := -3;
      break;
    end;
    if pos(a,'0123456789.+-')<>0 then t := t + a;
  end;
  if c <> 0 then exit;

  if (t = '') then begin
    result := false;
    C := 0;
  end else begin
    try
      c := strtocurr(t);
      result := true;
    except
      result := false;
      c := -1;
    end;
  end;

end;




function StrToFloatDef(const S:string;const F:Extended):Extended;
{ traps conversion error internally.
  Behaves as StrToIntDef()}
begin
  try
    Result := strtofloat(s);
  except
    Result := F;
  end;
end;




function SubStr(const S:string; const ToBeRepl:string; const ReplBy:string):string;
{ Replace one substring by another
  S : String           Host string.  REMAINS UNCHANGED
  ToBeRepl : String    To be removed
  ReplBy : String      To be substituted

  NOTE  Circular substitutions are allowed.
        If TobeRepl is null then result is S unchanged

  How to remove a whole set of characters:
    invalidchars := '/\?.:* ,';:#][=-+$^&"!%');
    for i := 1 to length(Invalidchars) do
        s := substr(s,InvalidChars[i],'');}


var
  W,X : string;
  p,ld: integer;
begin
  if S = '' then begin
    result := '';
    exit;
  end;
  if ToBeRepl = '' then result := S;    { trap sillies }
  if ToBeRepl = '' then exit;

  W := '';
  X := S;
  ld := length(ToBeRepl);

  while X <> '' do
    begin
      p := pos(ToBeRepl,X);
      case p of
        0 : begin
             W := W + X;
             X := '';
            end;
        1 : begin
             W := W + ReplBy;
             X := copy(X,ld+1,length(X)-ld);
            end;
      else
            begin
              W := W + copy(X,1,p-1) + ReplBy;
              X := copy(X,p+ld,30000)
            end;
      end;
    end;
   result := W;
end;




Function SubStrip(const S,ToStrip,ToSub:string):string;
{ multiple SUBSTR.  Typically used to strip a number of characters at a time.
  S       : String    Original
  ToStrip : String    Strings split by vertical bars to be replaced
  ToSub   : String    String to replace

  Example:   TidyStr := SubStrip(Str,' |.|,','');
             This would remove spaces, periods and commas completely
             }
var
  a,b,c : string;
begin
  b := s;
  a := Tostrip;
  while a <> '' do begin
    c := chop(a,'|');
    b := substr(b,c,ToSub);
  end;
  result := b;
end;




procedure tActivate(aTable:TTable);
{ put the table into the active state}
begin
  with aTable do begin
    if state = dsinactive then open;
  end;
end;




Procedure TagAndFlag(L:TLabel;Good:Boolean);
{ possibly reset the tag of the label (1=good,2=bad)
  Display the label according to the tag.

  See TagAndFlagValidate for full explanation
  }
begin
  with L do begin
    if good then begin
      tag := 1;
      font.color := TForm(Parent).font.color;
      color := TForm(Parent).color;
    end else begin
      tag := 2;
      font.color := clYellow;
      color := clRed;
    end;
  end;
end;




Procedure TagAndFlagAndHint(L:TLabel;Good:Boolean;Hint:string);
{ as TagAndFlag but with the addition of a hint which is shown when not good

  See TagAndFlagValidate for full explanation
}
begin
  TagAndFlag(L,Good);
  L.hint := Hint;
  l.Showhint := not good;
end;




procedure TagAndFlagFocus1stProb(F:TForm);
{ try to focus on the first input control which is marked as bad
  See TagAndFlagValidate for full explanation
}
var
  i : integer;
begin
  with F do begin
    for i := 0 to ComponentCount - 1 do begin
      if (Components[i].tag = 2) and (Components[i] is TLabel) then begin
        with Components[i] as Tlabel do begin
          FocusControl.setfocus;
          break;
        end;
      end;
    end;
  end;
end;




Function TagAndFlagValidate(F:TForm;AControl:TWinControl):boolean;
{  This is a way of flagging a number of controls on a form
   so that the label associated with data input controls
   shows red when there is a problem with the input.

   F is the form which will be validated in bulk

   AControl is a control that can be focussed which is NOT
   one of the edit controls being validated.  I habitually use
   a button.  Focus remains with this control at the finish
   of the procedure.

   Return false if one or more problems found.

   TUTORIAL
   1  Add an input control of some sort to the form
   2  Add a label, then with this label set two properties
      a Set the FocusControl property to the control created in 1
      b Set the tag to 1
      (Non-zero tags on labels without Focuscontrols are not allowed)
   3  Create an OnExit handler for the input control
      a Do whatever checking is required on the input value
      b If you're happy then set the tag of the associated label to 1
      c If you're not happy then set it to 2 (indicates fault)
      d Call a procedure that sets the .font.color and color properties
        of the label depending on the tag being 1=OK or 2=bad
      (The TagAndFlag procedure does b,c and d)

      Example OnExitProcedure
        // The name provided must be longer than 3 characters
        Tagandflag(laName,(length(ebName.text)>3));

      Example TagAndFlagValidate use
        // can we finish this form now?
        if TagAndFlagValidate(self,OkButton)
           then self.close
           else TagAndFlagFocus1stProb(self);

}
var
  i : integer;
begin
 result := true;
  with F do begin
    for i := 0 to ComponentCount - 1 do begin
      if (Components[i].tag in [1,2]) and (Components[i] is TLabel) then begin
        with Components[i] as Tlabel do begin
          //showmessage(caption);
          FocusControl.setfocus;
          application.processmessages;
          AControl.setfocus;
          application.processmessages;
          if tag = 2 then result := false;
          (*   Normally you would do the tag and flag in the exit routine.
               However if you chose just to set the tag then you'll need
               this line to do the swapping of colours
          TagAndflag((Components[i] as Tlabel),(tag=1));
          *)
        end;
      end;
    end;
  end;
end;




Function TD2D(const aDate:TTinyDate):TDateTime;
{ shorthand for TinyDatetoDateTime function}
begin
  result := TinyDatetoDateTime(aDate);
end;




procedure tDeActivate(aTable:TTable);
{ put the table into the inactive active state
  if necessary call post first}
begin
  with aTable do begin
    if state in [dsedit,dsinsert] then post;
    application.processmessages;
    if state <> dsinactive then close;
  end;
end;




Function TDEarlier(const FirstDate,SecondDate:TTinyDate):Boolean;
{ return true if the first date is certainly earlier than second
  (see Compare TD for details)}
begin
  result := (CompareTD(FirstDate,SecondDate)<0);
end;


Function TDIsPrecise(const aDate:TTinyDate):boolean;
{ return true if a day a month and a year are specified }
var
  y,m,d:word;
begin
  result := tdisreal(aDate);
  if result then result := (tdCompleteDate = DecodeTinyDate(aDate,y,m,d));
end;

Function TinyDaysDifference(const d1,d2:TTinydate):integer;
{ return number of days from d1 to d2.  If d2 is before d1 then return a negative }
begin
  if TdIsPrecise(d1) and TdIsPrecise(d2) then begin
    result := trunc(double(TD2D(d2))-double(TD2D(d1)))
  end else begin
    result := -99999;
    if TdEarlier(d1,d2) then result := 9999;
    if TdLater(d1,d2) then result := -9999;
  end;
end;

Function TDIsReal(const aDate:TTinyDate):boolean;
{ return true if aDate is a genuine date }
var
  y,m,d:word;
begin
  result := (adate>TDBOT) and (aDate<TDEOT) and (aDate<>TDNVD);
  if result then begin
    try
      decodetinydate(aDate,y,m,d);
      encodedate(y,m,d);
    except
      result := false;
    end;
  end;
end;




Function TDLater(const FirstDate,SecondDate:TTinyDate):Boolean;
{ return true if the first date is certainly later than second
  (see Compare TD for details)}
begin
  result := (CompareTD(FirstDate,SecondDate)>0);
end;




Function TextToTinyDate(const DS:String):TTinyDate;
{ convert the string into a date
  General format:   d-m-y or d/m/y or d m y or ddmmyy
                    d might be missing
                    d and m might be missing
                    m can be number or month name
                    two digit years are assumed to be in the future if they
                    are up to 5 years in the future otherwise in the past.
  Special values    "B...." = beginning of time
  (case insensitive)"E...." = end of time
                    "NVD" or "Not..." = Not a valid date
                    "T..." = Today
                    all spaces or blank = Not a valid date
  Any date that pretends to be real but is fake eg 30th Feb returns a null string.
  Any date not fitting the above is returned as a null string.

}
var
  s : string;
  icount ,i: integer;
  sixdigits : boolean;
  y,m,d,yy,mm,dd : word;
  dys,mos,yrs:string;
  A : array [0..5] of string;
  TinyDateTwoDigitCutoff : integer;
begin
  s := lowercase(trim(ds));
  d:=0;
  m:=0;
  y:=0;
  result := '';

  // deal with special values ---------------------
  if s = '' then begin
    result := TDNVD;
  end else begin
    if (s = lowercase(NODATESTR)) then result := TDNVD;
    if (s = lowercase(BEGOFTIMESTR)) then result := TDBOT;
    if (s = lowercase(ENDOFTIMESTR)) then result := TDEOT;
    if (s[1]='b') then result := TDBOT;
    if (s[1]='t') then result := TinyDNow;
    if (s[1]='e') then result := TDEOT;
  end;
  if result <> '' then exit;


  result := TDNVD;
  // possibly six digits
  sixdigits := false;
  if length(s)=6 then begin
    try
      d := strtointdef(copy(s,1,2),99);
      if (d > 0) and (d<=31) then begin
        m := strtointdef(copy(s,3,2),99);
        if (m > 0) and (m<=12) then begin
          y := strtointdef(copy(s,5,2),999);
          if (y<=99) then begin
            dys := copy(s,1,2);
            mos := copy(s,3,2);
            yrs := copy(s,5,2);
            sixdigits := true;
          end;
        end;
      end;
    except;  // silently deal with bloody akward input
    end;
  end;

  if not sixdigits then begin
    // chop into bits and try to interpret them ----
    icount := Stringtoarray(s,'-/ ',a);
    case icount of
    1 : begin       // year only or ddmmyy
          if (length(a[0])=6) and (strtointdef(a[0],99)>=10100) then begin
            dys := copy(a[0],1,2);
            mos := copy(a[0],3,2);
            yrs := copy(a[0],5,2);
          end else begin
            dys := '0';
            mos := '0';
            yrs := a[0];
          end;
        end;
    2 : begin       // day missing
          dys := '0';
          mos := a[0];
          yrs := a[1];
        end;
    3 : begin       // all present
          dys := a[0];
          mos := a[1];
          yrs := a[2];
        end;
    else
      result := '';   // uncertain - return "tried to read but failed"
      exit;
    end;{case}
  end;{six digits?}

  // condition the bits we have - trapping errors
  try
    d := strtointdef(dys,99);
    if (d > 31) then result := TDNVD;

    i := MonthStrToInt(mos);   // (i=int m=word)
    if i < 0 then result := TDNVD;
    m := abs(i);

    y := strtointdef(yrs,9999);
    if y = 9999 then result := TDNVD;
    if y = 0 then y := 2000;
    if y < 1900 then begin
      if y > 99 then begin
        result := TDNVD;   // dates from 99-1899 are not valid
      end else begin
        y := 1900 + y;
        decodedate(now,yy,mm,dd);
        TinyDateTwoDigitCutoff := yy-85;
        if y < TinyDateTwoDigitCutoff then y := y + 100;
      end;
    end;
  except
    result := '';   // trap bloody funny inputs
  end;
  if result = '' then exit;

  // we now have a d,m and y which are ok for a tiny date
  // but we might want to check to see if we have all the
  // bits necessary for a full date that the date is valid.
{$WARNINGS OFF}
  result := encodeTinydate(y,m,d);
  if (d > 0) and (m>0) and (y>=1900) then begin
    try
      encodedate(y,m,d);
    except
      result := '';
    end;
  end;
{$WARNINGS ON}

end;

(*
|Function EncodeTinyTime(const h,m:integer):TTinyTime;
|{ Creates a 2 character representation of hours and minutes.
|  if either h AND m is negative then return TTNVT
|  if h <> 0 and m>59 then TTNVT
|  if h  = 0 and m>59 then this is OK
|  if h<0 OR m<0 then this is a negative duration
|  Maximum number of minutes is
|*)




function TFData(const ADataSet:TDBDataset; Const AField:String):boolean;
{Read the current record in ADataset, indicated by AField
and return a boolean.  This is used on fields that are single
character fields used for boolean data 'T'=True any other=false
(because Paradox's "Logical" field type can't be used for
filtering)}
var
  v : Variant;
begin
  v := ADataset.fieldvalues[AField];
  if vartype(v) = $001 then
    result := False
  else
    result := ((string(v)='T')or(string(v)=DBTRUE));
end;



function StrLookup(const ADataSet:TDBDataset; Const KField,RField:String; const AKeyValue:variant):string;
{ general purpose lookup(see VCL docs) which returns a string
    Kfield is the fields we're indexing on using AKeyValue
    RField is the string field to return
}
var
  v : variant;
begin
  v := ADataSet.lookup(KField,AKeyValue,RField);    // basic lookup
  if vartype(v) = $001 then result := '**ERROR**'   // trap unsuitable data types
                       else result := string(v);
end;

function IntLookup(const ADataSet:TDBDataset; Const KField,RField:String; const AKeyValue:variant):Integer;
{ general purpose lookup(see VCL docs) which returns an integer
    Kfield is the fields we're indexing on using AKeyValue
    RField is the integer field to return
    return 0 if not found
}
var
  v : variant;
begin
  v := ADataSet.lookup(KField,AKeyValue,RField);    // basic lookup
  if (vartype(v) in [varsmallint,varinteger]) then result := v else result := 0;
end;



function TidyUpString(const aString:String):string;
{ convert control and funny characters into spaces
  De-duplicate spaces }
var
  r,s,c,cc : string;
  i : integer;
begin
  s := trim(aString);
  r := '';
  cc := '';
  for i := 1 to length(s) do begin
    c := copy(s,i,1);
    if (c < ' ') then c := ' ';
    if not((cc=' ') and (c=' ')) then r := r + c;
    cc := c;
  end;
  result := r;
end;




function TinyDateData(const ADataSet:TDBDataset; Const AField:String):TTinyDate;
{ Fetch a tiny date from the specified field/current record.
  The field can be either a TDateTime or a string containing a tiny date}
var
  d : Tdatetime;
  v : Variant;
  s : string;
begin
  v := ADataset.fieldvalues[AField];
  if vartype(v) = vardate then begin
    d := v;
    result := DateTimeToTinyDate(d);
  end else begin
    if vartype(v) = varnull then begin
      result := TDNVD;
    end else begin
      s := v;
      if (length(s)<>3) or (s<TDBOT) or (s>TDEOT) then begin
        result := TDNVD;
      end else begin
        result := copy(s,1,3);
      end;
    end;
  end;
end;


(*
function OLDTinyDateData(const ADataSet:TDBDataset; Const AField:String):TTinyDate;
{ ********* do not use *************
  Fetch a tiny date from the specified field/current record.
  The field can be either a TDateTime or a string containing a tiny date}
var
  d : Tdatetime;
  v : Variant;
  s : string;
begin
  v := ADataset.fieldvalues[AField];
  if vartype(v) = vardate then begin
    d := v;
    result := OLDDateTimeToTinyDate(d);
  end else begin
    if vartype(v) = varnull then begin
      result := OLDTDNVD;
    end else begin
      s := v;
      if (length(s)<>3) or (s<OLDTDBOT) or (s>OLDTDEOT) then begin
        result := OLDTDNVD;
      end else begin
        result := copy(s,1,3);
      end;
    end;
  end;
end;
*)


Procedure  TinyDateInCell(G:TDBGRID;const Rect: TRect;
                          datacol:integer; State:TGridDrawState);
{ convert the underlying TTINYDATE into a nice date in this grid position }
var
  s : string;
begin
  SetCellPaintingParameters(g,State);
  with g.canvas do begin
    brush.style := bsSolid;
    fillrect(rect);
    if assigned(g.fields[Datacol]) then begin
      s := tinydatestr(g.fields[Datacol].asstring);
      if s = 'No-Date' then s := '';
    end else begin
      s := '';
    end;
    textrect(rect,rect.left+2,rect.top,s);
  end;
end;




Function TinyDateStr(const aDate:TTinyDate):string;
{ return a date we can see from the tinydate }
var
  y,m,d : word;
  yy,mm,dd : string;
  rod : TTinyDateSpecialValue;
const
  Mnames = 'JanFebMarAprMayJunJulAugSepOctNovDec';
begin
  if adate=TinyDnow then begin
    result := 'Today';
    exit;
  end;

  rod := DecodeTinyDate(aDate,y,m,d);

  if (y>1960) and (y<2040) then yy := format('%2.2d',[y mod 100])
                           else yy := format('%4.4d',[y]);
  mm := '';
  if m > 0 then mm := copy(Mnames,(m*3)-2,3)+' ';
  if d = 0 then dd := '' else dd := inttostr(d)+' ';
  case rod  of
  tdCompleteDate : result := dd+mm+yy;
  tdYearOnly     : result := yy;
  tdYearMonthOnly: result := mm+yy;
  tdMonthOnly    : result := mm;
  tdMonthDayOnly : result := dd+mm;
  tdBegOfTime    : result := BEGOFTIMESTR;
  tdEndOfTime    : result := ENDOFTIMESTR;
  tdNotValid     : result := NODATESTR;
  end;
  result := trim(result);
end;


(*
Function OLDTinyDateStr(const aDate:TTinyDate):string;
{ ********* do not use ************
  return a date we can see from the tinydate }
var
  y,m,d : word;
  yy,mm,dd : string;
  rod : TTinyDateSpecialValue;
const
  Mnames = 'JanFebMarAprMayJunJulAugSepOctNovDec';
begin
  if adate=OLDTinyDnow then begin
    result := 'Today';
    exit;
  end;

  rod := OLDDecodeTinyDate(aDate,y,m,d);

  if (y>1960) and (y<2040) then yy := format('%2.2d',[y mod 100])
                           else yy := format('%4.4d',[y]);
  mm := '';
  if m > 0 then mm := copy(Mnames,(m*3)-2,3)+' ';
  if d = 0 then dd := '' else dd := inttostr(d)+' ';
  case rod  of
  tdCompleteDate : result := dd+mm+yy;
  tdYearOnly     : result := yy;
  tdYearMonthOnly: result := mm+yy;
  tdMonthOnly    : result := mm;
  tdMonthDayOnly : result := dd+mm;
  tdBegOfTime    : result := BEGOFTIMESTR;
  tdEndOfTime    : result := ENDOFTIMESTR;
  tdNotValid     : result := NODATESTR;
  end;
  result := trim(result);
end;
*)



Function TinyDatetoDateTime(const aDate:TTinyDate):TDateTime;
{ convert Tiny date into Delphi date
  No year and no day TinyDates will return not a valid date
  Don't forget that BOT and EOT are defined differently }
var
  y,m,d : word;
begin
  if adate = TDBOT then begin
    result := BegOfTime;
    exit;
  end;
  if adate = TDEOT then begin
    result := EndOfTime;
    exit;
  end;
  if adate = TDNVD then begin
    result := NotAValidDate;
    exit;
  end;
  try
    decodeTinydate(aDate,y,m,d);
    result := encodedate(y,m,d);
  except
    result := NotAValidDate;
  end;

end;

(*Function OLDTinyDatetoDateTime(const aDate:TTinyDate):TDateTime;
{ ******* do not use **********
  convert Tiny date into Delphi date
  No year and no day TinyDates will return not a valid date
  Don't forget that BOT and EOT are defined differently }
var
  y,m,d : word;
begin
  if adate = OLDTDBOT then begin
    result := BegOfTime;
    exit;
  end;
  if adate = OLDTDEOT then begin
    result := EndOfTime;
    exit;
  end;
  if adate = OLDTDNVD then begin
    result := NotAValidDate;
    exit;
  end;
  try
    decodeTinydate(aDate,y,m,d);
    result := encodedate(y,m,d);
  except
    result := NotAValidDate;
  end;

end;

*)

Function TinyDNow:TTinyDate;
{ Return current date time as expressed in a tidy date }
var
  d,m,y : word;
begin
 decodedate(Date,y,m,d);
 result := EncodeTinyDate(y,m,d);
end;

(*
Function OLDTinyDNow:TTinyDate;
{ ******* do not use *********
Return current date time as expressed in a tidy date }
var
  d,m,y : word;
begin
 decodedate(Date,y,m,d);
 result := OLDEncodeTinyDate(y,m,d);
end;
*)


Function TinySQLDate(Const D:TTinyDate):string;
{ Q: Why bother with this when surely we can use a TinyDate
     as a string and be done with it?
  A: Because it might include " which needs to be duplicated
  Example : ... where SomeDate = '+TinySqlDate(D)+' order by...}
begin
  result := ' "'+ substr(D,'"','""')+'" ';
end;




function ToCSV(s:string):string;
{ writeln but convert the string into CSV format
  ie 1) Top and tail with double quotes
     2) Duplicate embedded quotes
     3) Convert field separators of vertical bar into ","}
begin
  result := '"'+substr(substr(s,'"','""'),'|','","')+'"';
end;




function ToTSV(s:string):string;
{ writeln but convert the string into tab separated variable format
  ie 1) remove any existing tabs (replace with space)
     2) Convert field separators of vertical bar into tab}
begin
  result := substr(substr(s,#9,' '),'|',#9);
end;


(*function ForceRounding(const n:single):single;
{ this adds 1/10,000th to the value to ensure that .03500000 will get
  rounded up to .04 for currency calcs and presentation etc }
const
  tinybit = 0.0003;
begin
  if abs(n)<tinybit then begin
    result := n;
  end else begin
    if n > 0 then result := n + tinybit else result := n - tinybit;
  end;
end;
*)




Procedure Trap;
{This will normally do nothing but can be set to do anything you like
 eg showmessage.  But really for switching on multiple breaks in one point}
begin
    ;  {do nothing!!}
end;



function TryEdit(aTable:TTable):boolean;
{ A wrapper round the EDIT method.  This will trap locks and allow us to
  try again etc.  Return false if we can't get to editing the table }
var
  again : boolean;
begin
  again := false;
  repeat
    begin
      try
        atable.edit;
      except
        on e: EDatabaseError do begin
          again := confirmbox('TROUBLE ACCESSING A RECORD IN '
                  +atable.tablename
                  +'|TRY AGAIN?|('
                  +e.message+')');
        end;
      end;
    end;
  until not again;
  result := (atable.state = dsedit);
end;


procedure forceQueryReload(Q:TQuery);
{ TQuery.refresh doesn't seem to act as advertised!
  This reloads the query}
begin
  try Q.close; except; end;
  Q.open;
end;



function TryPost(aDataset:TBdeDataset):boolean;
{ only posts if in edit mode flushes buffers
  return false if an error while posting }
begin
  result := true;
  with adataset do begin
    if modified then begin
      try
        post;
        flushbuffers;
      except;
        result := false;
      end;
    end;
  end;
end;




Function TW(const S:string):integer;
{ shorthand for Printer.canvas.textwidth function }
begin
  result := Printer.canvas.textwidth(S);
end;




function TwoDecimals(const C:currency):currency;
{ return the argument truncated to two or fewer decimals }
begin
  if not strtocurrency(nicepounds(C,false),result) then result := -1;
end;




procedure uFileCopy(const FromFile, ToFile: string);
{ COPY A FILE }
var
  ok : Longbool;
begin
  ok := false;
  copyfile(pchar(FromFile),pchar(ToFile),ok);
(*var
  FromF, ToF: file;
  NumRead, NumWritten: Integer;
  Buf: array[1..1024] of Char;
begin

  AssignFile(FromF, FromFile);
  Reset(FromF, 1);		{ Record size = 1 }
  AssignFile(ToF, ToFile);	{ Open output file }
  Rewrite(ToF, 1);		{ Record size = 1 }
  repeat
    BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
    BlockWrite(ToF, Buf, NumRead, NumWritten);
  until (NumRead = 0) or (NumWritten <> NumRead);

  System.CloseFile(FromF);
  System.CloseFile(ToF);
*)
end;




Function UnCapitalise(const S:String):string;
{ turn words that are completely capitialised into proper names
  eg SMITH --> Smith }
var
  c : string;
  i : integer;
  u : boolean;
begin
  u := true;
  result := '';
  for i := 1 to length(S) do begin
    c := copy(s,i,1);
    if u then result := result+c else result := result + lowercase(c);
    u := false;
    if c < 'A' then u:=true;
  end;
end;



procedure setfield(const ADataSet:TDBDataset; Const AField:String; NewData:variant);
{ put the dataset into edit mode if not already (and leave it there)
  Set the field to the value }
begin
  With ADataset do begin
    if fieldvalues[AField] = NewData then exit;
    if state <> dsedit then edit;
    fieldvalues[AField] := NewData;
  end;
end;

procedure Updatefield(const ADataSet:TDBDataset; Const AField:String; NewData:variant);
{ same as SETFIELD() but posts the data and leaves the dataset in browse}
begin
  if Adataset.fieldvalues[AField] = NewData then exit;
  setfield(ADataSet,Afield,Newdata);
  trypost(Adataset);
end;




procedure UpdateStrData(var ATable:TTable; Const AField,NewData:string;const EraseOnly:Boolean);
{ if the new value is different then update
  Make sure we're not duplicating
  ATABLE .... Name of a table
  AFIELD .... Name of a string field
  NEWDATA ... String to make the current record, named field
  If ERASEONLY is true then if the supplied string is already present then remove it}
var
  s : string;
begin
  s := strdata(ATable,AField);
  if eraseonly then begin
    if pos(newdata,s)=0 then exit;
    s := substr(s,newdata,'');
  end else begin
    if s = newdata then exit;
    s := newdata;
  end;
  with ATable do begin
    if tryedit(aTable) then begin
      fieldvalues[AField]:=s;
      post;
    end;
  end;
end;




function ValidVariant(const V:Variant):boolean;
{ return false if argument is null or empty}
begin
   result := not(varisempty(V) or varisnull(V));
end;




function Vscrollwidth:integer;
{ HOW MANY PIXELS WIDE IS THE VERTICAL SCROLL BAR?}
begin
     result := GetSystemMetrics(SM_CXHTHUMB);
end;




Function WhereOrAnd(const SQL,Condition:string):string;
{ We often want to add conditions to a WHERE expression
  of an SQL statement.  We can get into a bit of a twist
  with multiple conditions.  This ensures there is one
  WHERE and any subsequent are ANDs

  Returns the combination of SQL + Condition with
  the appropriate WHERE or AND in between}
var
  con : string;
begin
  con := ' WHERE ';
  if pos('where',lowercase(SQL)) <> 0 then con := ' AND ';
  result := SQL + con+ '(' + condition+ ') ';
end;


Procedure WhiteOnGrey;
{ set the printer to print white characters on a grey background
  automatically set the font to bold
  May need to be called as useful.WhiteOnGrey
  See also BlackOnWhite
  Some printers/printer drivers are no good at this.
  }
begin
  with printer.canvas do begin
    font.color := clwhite;
    brush.color := clsilver;
    font.style := font.style + [fsbold];
  end;
end;
Procedure BlackOnGrey;
{ set the printer to print white characters on a grey background
  automatically set the font to bold
  May need to be called as useful.BlackOnGrey
  See also BlackOnWhite
  Some printers/printer drivers are no good at this.
 }
begin
  with printer.canvas do begin
    font.color := clBlack;
    brush.color := clsilver;
    font.style := font.style + [fsbold];
  end;
end;


Procedure WhiteOnBlack;
{ set the printer to print white characters on a back background
  automatically set the font to bold
  May need to be called as useful.WhiteOnBlack
  See also BlackOnWhite
  Some printers/printer drivers are no good at this.
}
begin
  with printer.canvas do begin
    font.color := clwhite;
    brush.color := clblack;
    font.style := font.style + [fsbold];
  end;
end;



function WinExecAndWait(const FileName:String; const Visibility : integer):LongWord;
{ Execute FILENAME (which might include arguments)
  VISIBILITY is something like SW_SHOWNORMAL
  Wait for process to finish before returning

  sourced (with minor mods) from Unoffical Delphi Developers FAQ,
  http://www.gnomehome.demon.nl/uddf/uddf.zip
}
var
  zAppName:array[0..512] of char;
  zCurDir:array[0..255] of char;
  WorkDir:String;
  StartupInfo:TStartupInfo;
  ProcessInfo:TProcessInformation;
begin
  StrPCopy(zAppName,FileName);
  GetDir(0,WorkDir);
  StrPCopy(zCurDir,WorkDir);
  FillChar(StartupInfo,Sizeof(StartupInfo),#0);
  StartupInfo.cb := Sizeof(StartupInfo);

  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := Visibility;
  if not CreateProcess(nil,
    zAppName,                      { pointer to command line string }
    nil,                           { pointer to process security attributes }
    nil,                           { pointer to thread security attributes }
    false,                         { handle inheritance flag }
    CREATE_NEW_CONSOLE or          { creation flags }
    NORMAL_PRIORITY_CLASS,
    nil,                           { pointer to new environment block }
    nil,                           { pointer to current directory name }
    StartupInfo,                   { pointer to STARTUPINFO }
    ProcessInfo) then Result := 0  { pointer to PROCESS_INF }

  else begin
    WaitforSingleObject(ProcessInfo.hProcess,INFINITE);
    GetExitCodeProcess(ProcessInfo.hProcess,Result);
  end;
end;




procedure WrapIntoGridCell(Sender: TObject; C, R: integer;
  Rect: TRect; State: TGridDrawState);
{the sort of thing where we have multi line displays for
 displaying in a grid.  Actually the wrap only works
 with hard returns ie #13+#10}
var
  V : integer;
  nl,S,T :String;
begin
  nl := #13+#10;
  with sender as TStringGrid do begin
    S := cells[c,r];
    // lose any trailing New Line
    if length(s)>=2 then begin
      if copy(S,length(S)-1,2)=nl then S := copy(S,1,length(S)-2);
    end;
    V := rect.top;
    with canvas do begin
      fillrect(rect);
      while S <> '' do begin
        T := chop(S,nl);
        textout(rect.left,V,T);
        V := V + Textheight(T);
      end;
    end;
    if (V-rect.top) > rowheights[r] then rowheights[r] := V-rect.top;
  end;
end;


function ReadCSVLine(const s:string;var a:array of string):integer;
{ convert a single CSV line into fields
  NB don't forget array F indexing starts at [0] }
var
  c : string;
  inquotes : boolean;
  f,i : integer;
begin
  result := 0;
  inquotes := false;
  if S = '' then exit;       // nothing in the string
  f := low(a);
  a[f]:= '';
  for i := 1 to length(s) do begin
    c := copy(S,i,1);
    if c = '"' then begin
      inquotes := not inquotes;
    end else begin
      if c = ',' then begin
        if not inquotes then begin
          inc(f);
          if f > high(a) then begin
            f := -1;
            break;
          end;
          a[f] := '';
        end else begin
          a[f] := a[f]+c;
        end;
      end else begin
        a[f] := a[f]+c;
      end;
    end;
  end;
  result := f;

  // return the NUMBER of strings which is 1 more than HIGHEST used
  if result > -1 then  result := result + 1;
end;


procedure DataModuleOpenClose(DM:TDataModule;const Action:string);
{ open or close all the TTable components of the specified datamodule
   Action is "Open" or "Close"

   This might be used when you are about to do a security backup
   from within the program which will mean you need all the
   data files closed first.

   NB if you have queries then you may need to close these also
   or change "TTable" to "TDataSet".

 }
var
  i : integer;
  opening : boolean;
begin
  opening := uppercase(copy(action,1,1))='O';
  hourglass(true);
  for i := 0 to dm.ComponentCount-1 do begin
    if dm.Components[i] is TTable then begin
      with dm.components[i] as TTable do begin
        application.processmessages;
        if active then begin                       // always closing means that OPEN
          try
            active := false;                       // on an already open table forces
            application.processmessages;           // a refresh
          except;end;
        end;
        if opening then begin
          try
            open;
            application.processmessages;
          except
            on e:exception do begin
              showmessage('ERROR while trying to open component:'+name
                         +' on table:'+tablename+'. Error:'+e.message);
            end;
          end;{try/except}
        end;
      end;
    end;{with dm.component}
  end;{for loop}
end;



procedure EditPostandFlush(ATable:TTable;aFieldName:string;aValue:Variant);
{ edit the table...stuff the value into the field and post with flush buffers }
begin
  if tryedit(aTable) then begin
    aTable.fieldvalues[aFieldName]:=aValue;
    trypost(aTable);
    aTable.flushbuffers;
  end;
end;


constructor TInteger.new(const i:Integer);
{ an OBJECT }
begin
  inherited create;
  value := i;
end;

constructor TTDate.new(const d:TTinydate);
{ an OBJECT }
begin
  inherited create;
  value := d;
end;


procedure GreyOut(eb:TControl;enable:boolean);
{ disables and shows in grey (or enables and shows in clWindow)}
var
  clr : Tcolor;
begin
  if enable then clr := clWindow else clr := clsilver;
  if eb is Tedit then with eb as Tedit do color := clr;
  if eb is TLabel then with eb as TLabel do color := clr;
  if eb is TDBLookupComboBox then with eb as TDBLookupComboBox do color := clr;
  eb.enabled := enable;
end;


function ReadNBNQln(var f:TextFile;const remarkflag:string; var s:string):boolean;
{ read next NON-BLANK line
  Remove trailing remarks as determined by remarkflag
  example of remarkflag is "//|#" which removes remarks following "//" and "#"
  Return false if EOF }
var
  i : integer;
  r : string;
begin
  r := remarkflag;
  while ReadNBln(f,s) do begin  // fetch non blank lines
    while r <> '' do begin        // hunt for trailing remarke
      i := pos(chop(r,'|'),s);
      if i <> 0 then begin
        if i = 1 then s := '' else s := trimright(copy(s,1,i-1));
      end;
      if s = '' then break;
    end;
    if s <>'' then break;
  end;
  result := (s<>'');
end;


function ReadNBln(var f:TextFile;var s:string):boolean;
{ read next NON BLANK line.
  Return false if EOF.
  see also ReadNBNQln
}
begin
  s := '';
  while ((s='') and (not eof(f))) do begin
    readln(f,s);
  end;
  result := (s<>'');
end;


Function ArrayToString(const sep:string; const A: array of string):string;
{ concatenate all the items in the array into a single string
  sep is the string used to separate items
  All the array items are concatenated.

  NB This is really intended for arrays built on the fly because the size of the
  array determines the number of fields written.  However if you're writing records
  to which have the same number of fields then make sure you specify the right
  number of fields in the array and blank out those not used.

  example:
  |  s := ArrayToString('|',['Today','is',datestring]);
}
var
  i : integer;
  s : string;
begin
  s := '';
  for i := low(a) to high(a) do begin
    if i = low(a) then s := A[i] else s := s + sep+A[i];
  end;
  result := s;
end;



function tinyddmmyy(const d:TTinydate):string;
{ return date in ddmmyy format }
begin
  result := formattd('ddmmyy',d);
end;




function tinydmmmyy(const d:TTinydate):string;
{ return date in d mmm yy format }
begin
  result := formattd('d mmm yy',d);
end;




function CloseToBottomOfPage(const BotMargInmm:integer):boolean;
{ return true if we are at or less than the bottom margin }
begin
  result := (PY > (printer.pageheight - pix(BotMargInmm)));
end;



Function Randomquote(const afilename:string):string;
{ Selects a line at random from the specified file
  nb you might want to call randomize first;

  Useful for when your application takes a while to start up
  first thing in the morning.
}
var
  BF : File;
  Buf: array[1..1024] of Char;
  s,q : string;
  fpos,lof,numread : integer;
begin
  if not fileexists(afilename) then begin
    result := 'The quotes file:'+afilename+' is missing';
  end else begin
    assignfile(BF,afilename);
    reset(BF,1);
    lof := filesize(BF)-100;
    fpos  := random(lof);
    seek(BF,fpos);
    BlockRead(BF, Buf, SizeOf(Buf), NumRead);
    closefile(BF);
    s := buf;
    q := chop(s,#10);   // throw away
    q := chop(s,#13);   // a complete line
    result := q;
    LASTQUOTE := q;     // save globally
  end;
end;



Function TstampStr(const DT:TDateTime):string;
{ return a string being the numeric version of the date supplied  eg "36531.034324"
  useful when SQLing with database fields where field is a number not a Timestamp
  }
begin
  result := format('%11.5f',[double(DT)]);
end;



Function FullparseOfFileName(const fname:string; var drive,path,name,ext:string):boolean;
{ properly cut up the filename supplied into the bits.
  return true if drive+path+name+ext = fname   ie. if parse was a success
  if not blank then...
    drive will be like "C:"
    path will end with a "\"
    filename won't have a trailing "."
    extension will have leading "."
  }
begin
  drive := extractfileDrive(fname);
  path := extractfilepath(fname);
  name := extractfilename(fname);
  ext  := extractfileext(fname);
  path := substr('^'+path,'^'+drive,'');  // remove any drive from the path
  name := substr(name+'^',ext+'^','');    // remove any ext from the name
  result := (fname = drive+path+name+ext);
end;



Function TestThisMutex(const IDString:string):THandle;
{  Returns 0 if the mutex already exists
   otherwise a handle that ought to be released at some stage
   see ISANOTHERCOPYRUNNING function }
var
  muxname : Array[0..255] of Char;
begin
  StrPCopy(MuxName, IDString);
  result := CreateMutex(nil,true,MuxName);
  if getlasterror=ERROR_ALREADY_EXISTS then result := 0;
end;


Function IsAnotherCopyRunning(const IDString:string):boolean;
{  This is used to prevent multiple copies of a program running

   In the main form or the project source
     if IsAnotherCopyRunning('MyAppName') then application.terminate;

   When the application terminates (eg main form closes) put
     ReleaseAnotherCopyMutex; }
begin
  AnotherCopyMutexHandle := TestThisMutex(IDString);
  result := (AnotherCopyMutexHandle=0);
end;


Procedure ReleaseAnotherCopyMutex;
{ call this when app terminates if using IsAnotherCopyRunning }
begin
  if AnotherCopyMutexHandle <> 0 then releasemutex(AnotherCopyMutexHandle);
end;



function isDriveReady(const drive:string) : boolean;
{ Returns true if specified drive is ready }
var
  DriveNo: byte;
  PrevInt24: word;
  s : string;
  DriveChar : char;
begin
  s := uppercase(drive+'A');
  DriveChar := s[1];
  DriveNo := ord(DriveChar)-ord('A')+1;
  PrevInt24 := SetErrorMode(SEM_FAILCRITICALERRORS);
  Result := (DiskFree(DriveNo) <> -1);
  SetErrorMode(PrevInt24);
end;



function HomeDirectory:string;
{ return the path of the executable }
begin
  result := extractFilePath(application.exename);
end;



(*
Function OLDEncodeTinyDate(const y,m,d:word):TTinyDate;
{ OBSOLETE - DO NOT USE
  companion to DECODETINYDATE q.v.
  The purpose is to have a compact form of date (3 character string)
  that can be used in a database which allows us to have incomplete and not-valid dates.
  The earliest valid date is 1 Jan 0001 the latest is 31 Dec 4096 }
var
  c1,c2,c3 :byte;
begin
  c3 := ((m and 3) shl 5)+(d and 31);
  c2 := ((y and 31) shl 2)+((m and 15)shr 2);
  c1 := ((y shr 5) and 127);
  Result := chr(c1+33)+chr(c2+33)+chr(c3+33);
end;


Function OLDDecodeTinyDate(const TinyDate:TTinyDate; var y,m,d:word):TTinyDateSpecialValue;
{ *********** DO NOT USE ****************
  companion to ENCODETINYDATE q.v.
  Decodes TinyDate to y,m and d as expected but also the return value
  might be quite significant as TinyDate is not necessarily a complete
  date.   Se the definition of TTinyDateSpecialValue above }
var
  c1,c2,c3 : integer;
begin
  if length(Tinydate)<>3 then begin
    result := tdNotValid;
    y := 1;
    m := 1;
    d := 1;
  end else begin
    // convert characters back into numbers
    c1 := Ord(TinyDate[1])-33;
    c2 := Ord(TinyDate[2])-33;
    c3 := Ord(TinyDate[3])-33;
    // unpack the y,m and d
    d := c3 and 31;
    m := (c3 shr 5) + ((c2 and 3) * 4);
    y := (c2 shr 2) + (c1 shl 5);
    // look for special values to give us a return code

    (*
       Y   M    D                 Interpretation
     --------------------------------------------------------------
       0   0    0                           Not a valid date
       0   0    1                           Beginning of time
       0   n    0     (n<>0)                Month only
       0   n    n     (n<>0)                Year not applicable
       1   0    0     Year 1                Year only
       1   1    1     1st Jan 0001          Earliest valid Full date
     1966  0    0     1966                  Year only
     1966  6    0     June 1966             Day missing
     1966  6    6     6th June 1966         Full date
     1966  0    6     !                     Not a valid date
     3964 12   31     31st Dec 3964         Last valid full date
     3965  x    x                           End of time


     if (y=3965) then begin
       result := tdEndOfTime;
     end else begin
       if (y=0) then begin
         if (m=0) then begin
           if (d=0) then result := tdNotValid else result := tdBegOfTime;
         end else begin
           if (d=0) then result := tdMonthOnly else result := tdMonthDayOnly;
         end;
       end else begin
         if (m=0) then begin
           if (d>0) then result := tdNotValid else result := tdYearOnly;
         end else begin
           if (d=0) then result := tdYearMonthOnly else result := tdCompleteDate;
         end;
       end;
     end;
  end;
end;
*)

Function DecodeTinyDate(const TinyDate:TTinyDate; var y,m,d:word):TTinyDateSpecialValue;
{ companion to ENCODETINYDATE q.v.
  Decodes TinyDate to y,m and d as expected but also the return value
  might be quite significant as TinyDate is not necessarily a complete
  date.   Se the definition of TTinyDateSpecialValue above }
var
  c1,c2,c3 : integer;
begin
  if length(Tinydate)<>3 then begin
    result := tdNotValid;
    y := 1;
    m := 1;
    d := 1;
  end else begin
    // convert characters back into numbers
    c1 := Ord(TinyDate[1]);
    c2 := Ord(TinyDate[2]);
    c3 := Ord(TinyDate[3]);
    // unpack the y,m and d
    y := ((c1 and $3F) shl 3) + ((c2 and $38) shr 3);
    m := ((c2 and $07) shl 1) + ((c3 and $20) shr 5);
    d := c3 and $1F;
    // look for special values to give us a return code

    (*
       Y   M    D                 Interpretation
     --------------------------------------------------------------
       0   0    0                           Not a valid date
       0   0    1                           Beginning of time
       0   n    0     (n<>0)                Month only
       0   n    n     (n<>0)                Year not applicable
       1   0    0     Year 1                Year only
       1   1    1     1st Jan 0001          Earliest valid Full date
     1966  0    0     1966                  Year only
     1966  6    0     June 1966             Day missing
     1966  6    6     6th June 1966         Full date
     1966  0    6     !                     Not a valid date
      500 12   31     31st Dec 3964         Last valid full date
      511  x    x                           End of time


     |  Year = 0..500    0=No year    1=Not valid date  2=Beg.of.time  511= EndOfTime
     |  Month = 1..12    0=No month
     |  Day = 1..31      0=No day


     *)

     // special pseudo dates
     if (y=1) then begin
       result := tdNotValid;
       y := 0;
       exit;
     end;
     if (y=2) then begin
       result := tdBegOfTime;
       y := y + 1700;
       exit;
     end;
     if (y=511) then begin
       result := tdEndOfTime;
       y := y + 1700;
       exit;
     end;
     if (y=0) then begin
       // no year
       if (m=0) then begin
         if (d=0) then result := tdNotValid else result := tdBegOfTime;
       end else begin
         if (d=0) then result := tdMonthOnly else result := tdMonthDayOnly;
       end;
     end else begin
       // we have a real year
       y := y + 1700;
       if (m=0) then begin
         if (d>0) then result := tdNotValid else result := tdYearOnly;
       end else begin
         if (d=0) then result := tdYearMonthOnly else result := tdCompleteDate;
       end;
     end;
  end;
end;

Function EncodeTinyDate(const y,m,d:word):TTinyDate;
{ companion to DECODETINYDATE q.v.
  The purpose is to have a compact form of date (3 character string)
  that can be used in a database which allows us to have incomplete and not-valid dates.
  The earliest valid date is 1 Jan 1703 the latest is 31 Dec 2200 }
var
  yy : integer;
  c1,c2,c3 :byte;
begin
  yy := y-1700;
  if yy > 500 then yy := 511;   //EOT
  // 1702 ... BOT
  // 1701 ... NVD
  if yy < 0 then yy := 0;       //zero

  c1 := $40+(yy shr 3);                                // 0 1 y y y y y y
  c2 := $40+($38 and (yy shl 3))+($07 and (m shr 1));  // 0 1 y y y m m m
  c3 := $40+($20 and (m shl 5)) +($1f and d);          // 0 1 m d d d d d
  Result := chr(c1)+chr(c2)+chr(c3);
end;

(*
function ConvertTD(B:TTinydate):TTinydate;
{ convert old format to new format tiny dates }
var
  dd,mm,yy : word;
  r : TTinyDateSpecialValue;
begin
  if B = OLDTDNVD then result := TDNVD
   else if B = OLDTDBOT then result := TDBOT
    else if B = OLDTDEOT then result := TDEOT
     else begin

       try
         r := OldDecodeTinyDate(B,yy,mm,dd);
       except
         showmessage('OldDecodeTinydate Failed');
         r := tdNotValid;
       end;

       case r of
       tdCompleteDate : result := EncodeTinyDate(yy,mm,dd);
       tdBegOfTime    : result := TDBOT;
       tdEndOfTime    : result := TDEOT;
       tdNotValid     : result := TDNVD;
       else
         result := encodetinydate(yy,mm,dd);
       end;{case}
     end;
end;
*)

procedure SetFontOnAllForms(const fName:String; fSize:Integer);
{ set the font on all the forms in this application }
var
  i : integer;
begin
  with application do begin
    for i := 0 to componentcount-1 do begin
      if components[i] is Tform then begin
        with components[i] as Tform do begin
          if fname <> '' then font.name := fname;
          if fsize <> 0 then font.size := fsize;
        end;
      end;
    end;
  end;
end;



Function CfgFileName:string;
{ return the application executable with a cfg extension
  ** UNLESS WE'RE OPERATING WITH THE DELPHI IDE SOMEWHERE WHICH USES CFG FOR ITSELF **
     In which case add "App before the spot}
begin
  Result := changefileext(application.exename,'.cfg');
  // trap for if we're running with the dvnt system
  // 'cos the dvnt system has a .cfg file already which causes conflict
  if fileexists(changefileext(application.exename,'.dpr')) then begin
    result := SubStr(Result,'.','App.');
  end;
end;



function PathForAlias(const AName:string):string;
{ return the full path for the specified alias
  NB Doesn't have terminating slash }
var
  L : Tstringlist;
begin
  result := 'Can''t find alias:'+aname;  // default = error
  L := TStringlist.create;
  TRY
    session.GetAliasParams(Aname,L);
    result := L.values['PATH'];
  FINALLY
    L.free;
  END;
end;


procedure PaintRectangle(const l,t,r,b,penwidth:integer; clr:Tcolor; canv:Tcanvas);
{ draw an outline rectangle with the polygon method }
begin
  with canv do begin
    pen.width := penwidth;
    pen.color := clr;
    Polyline([Point(l, t), Point(r, t), Point(r,b), Point(l,b), Point(l,t)]);
  end;
end;


function ReallyAssigned(p:Tobject):boolean;
{ Only return true if the object really exists
  ie trap dangling pointers }
begin
  result := false;
  try
    if (p <> nil) then begin
      if p.classname <> '' then result := true;
    end;
  except
    ;
  end;
end;

function ComputerName:string;
{ returns the name of the computer as set in the registry }
begin
  result := ReadRegString(HKEY_LOCAL_MACHINE,
               'System\CurrentControlSet\Control\ComputerName\ComputerName',
               'ComputerName')
end;

function ReadRegString(const Root:HKEY;const PathKey,ValueKey:string):string;
{ read value from the system registry
  eg  s := ReadRegString(HKEY_CURRENT_USER,'Software\My App\Settings','Mode');
  Returns empty string if not found
}
var
  R : Tregistry;
begin
  R := Tregistry.create;
  R.Rootkey := Root;
  R.openKey(PathKey,false);
  Result := R.ReadString(ValueKey);
  R.free;
end;


procedure WriteRegString(const Root:HKEY;const PathKey,ValueKey,Value:string);
{ write value to the system registry
  eg  WriteRegString(HKEY_CURRENT_USER,'Software\My App\Settings','Mode','Warm as toast');
  Creates the key if necessary
}
var
  R : Tregistry;
begin
  R := Tregistry.create;
  R.Rootkey := Root;
  R.openKey(PathKey,true);
  R.WriteString(ValueKey,Value);
  R.free;
end;


function TidyFileName(const SomeString:string):string;
{ Ensure that the returned value is a decent file name
  Return "ERROR" if there is nothing worth using
  Trim to max of 30 characters }
var
  s,ss : string;
  c : string;
  i : integer;
  lastspace : boolean;
begin
  s := '';
  LastSpace := true;
  ss := TidyUpString(SomeString);
  for i := 1 to length(ss) do begin
    c := ss[i];
    if pos(uppercase(c),' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ') = 0 then continue;
    If c=' ' then begin
      LastSpace := true;
      continue;
    end;
    c := Lowercase(c);
    if LastSpace then C := Uppercase(c);
    s := s + c;
    LastSpace := false;
  end;
  if s = '' then result := 'ERROR' else result := S;
  if length(result)> 30 then result := copy(s,1,30);
end;



procedure FreeListObjects(L:Tlist);
{ Run through all OBJECTS of the list freeing them }
var
  i : integer;
begin
  if assigned(L) then begin
    for i := 0 to L.count-1 do begin
      tobject(L.items[i]).free;
    end;
  end;
end;


procedure ExtendForm(F:Tform);
{ ensure all controls are visible }
var
  r,b,rmax,bmax,i : integer;
begin
  rmax := F.clientwidth;
  bmax := f.clientheight;
  for i := 0 to F.componentcount-1 do begin
    if F.components[i] is tcontrol then begin
      with F.components[i] as tcontrol do begin
        if parent = F then begin
          r := left + width;
          b := top + height;
          if r > rmax then rmax := r;
          if b > bmax then bmax := b;
        end;
      end;
    end;
  end;
  F.clientwidth := rmax+5;
  F.clientheight := bmax+5;
end;


function RandomString(const nocharstoreturn:integer):string;
{ return a random string containing letters and numbers but no characters
  that can be mistaken eg zero and oh.

  (The reason for avoiding anything that could be mis-interpreted is that
   this sort of thing often needs to be supplied as a user ID and it saves
   so much trouble if there is never any question of "ell" or "one".)

  With the characters provided there are 1/3rd million combinations in 4 characters.

  Caller should do a randomize() first }
const
  X='ACDEFGHJKLMNPRTUVWXY34679';  // Could add lwr case or I1-0O-Z2-8B
var
  i,lx : integer;
begin
  result := '';
  lx := length(X);
  for i := 1 to nocharstoreturn do begin
    result := result + copy(X,1+random(lx),1);
  end;
end;



function UniqueID(const ADataSet:TDBDataset; Const AField:String):string;
{ This is used to generate a unique string ID for a primary key.  The
  field is bound to be the first and it must be a string.
  You would then use it to do an appendrecord
  eg  uid := UniqueID(MyTable,'IdField')
      MyTable.appendRecord([uid,foo,bar,baz]);
}
var
  s : string;
  lf : integer;
begin
  lf := adataset.fieldbyname(Afield).size;
  s := Randomstring(lf);
  while adataset.locate(Afield,s,[]) do s := Randomstring(lf);
  result := s;
end;


function GetExclusiveCounter(exclTable,targetTable:Ttable):integer;
{  This is a replacement mechanism for autoincrement which was found
   to be unreliable in a network situation.  (Also there are other
   problems with auto increment so this is less restricting.

   EXCLTABLE is a table with the following field definition
     XxTable     String  - Used to hold the name of a table
     XxLastId    Integer - This is the last ID issued
   This table must have the Exclusive property set to true.

   TARGETTABLE is the table for which we want the next unique number
     We only use the .TABLENAME property of TARGETTABLE and otherwise
     don't touch it.  The caller will use the returned value as
     appropriate. (Perhaps in appendrecord.)

   Legal values are >0

   ECantGetExclusiveCounter is raised if
   * there is a problem getting exclusive access to ExclTable.
   * After a number of tries and user intervention still can't get access

   Note: Although normally this will produce unique sequential numbers
   the XxLastID fields could be altered by some other means which would
   disturb the sequence.  For example you might want your 2002 invoices to
   be serialised in the form 2002xxxxx in which case you'd set the XxLastID
   field relating to say the INVOICE table to 200200000

}

var
  i : integer;
  tname : string;
const
  ATTEMPTS = 10;
begin
  // check this really is exclusive
  if ExclTable.exclusive <> true then begin
    raise ECantGetExclusiveCounter.create('Table:'+exclTable.tablename+' isn''t exclusive');
  end;

  result := -1;
  tname := targettable.TableName;


  TRY  // it would be sinful to open an exclusive table and leave it like that!!
    while true do begin  // let user have multiple tries
      // try to get lock
      for i := 1 to ATTEMPTS do begin
        try
          ExclTable.open;
          break;
        except;end;
        sleep(100);
      end;

      with ExclTable do begin

        // we could not open the exclusive table
        if not active then begin
          if not confirmbox('Having trouble getting a serial number for '+tname+
                            '|Try again?') then begin
            raise ECantGetExclusiveCounter.create('Could not get serial number for '+
                            tname+' at '+formatdatetime('hh:mm:ss  on d mmm',now));
                            {if we really wanted to list the other users dbiopenuerlist might work}
          end;
          continue;  // try again
        end;

        // table opened OK
        if locate('XxTable',Tname,[]) then begin
          // normal - just count up
          result := intdata(ExclTable,'XxLastID')+1;
          edit;
          fieldvalues['XxLastID']:= result;
          post;
        end else begin
          // first time - set up from 1
          result := 1;
          appendrecord([tname,1]);
        end;
        break;  // all done

      end;
    end;{repeat}
  FINALLY
    if ExclTable.active then ExclTable.close;
  END;

end;


procedure WriteToRichEdit(re:Trichedit; const s:string; fnt:tfont; newline:boolean);
{ append string to richedit control
  newline = true if _followed_ by a new line }
begin
  with re do begin
    with selattributes do begin
      color := fnt.color;
      size := fnt.size;
      name := fnt.name;
      style := fnt.style;
    end;
    sellength := 0;
    seltext := s;
    if newline then lines.add('');
  end;
end;

procedure WriteToRichEdit(re:Trichedit; const s:string;
                          clr:tcolor; const fsize:integer;
                          bold,newline:boolean);
{ append string to richedit control
  fsize = font size
  newline = true if _followed_ by a new line }
begin
  with re do begin
    with selattributes do begin
      color := clr;
      if fsize > 0 then size := fsize;
      if bold then style := [fsbold] else  style := [];
    end;
    sellength := 0;
    seltext := s;
    if newline then lines.add('');
  end;
end;



function DobToAgeStr(const dob:TTinydate):string;
{ convert DOB into an age in years }
var
  agedy : integer;
  age : single;
  fmt : string;
begin
  // DOB in future is daft
  if dob > tinydnow then begin
    result := '!!';
    exit;
  end;

  // missing dob is left blank
  if (dob = TdNVD) or (dob=TdBot) then begin
    result := '';
    exit;
  end;

  // ordinary age (show 1dp if < 2 years old)
  agedy := TinyDaysDifference(dob,tinydnow);
  age := agedy;
  age := age / 365.0;  // years
  if age < 2 then fmt := '%2.1f' else fmt := '%3.0f';
  result := format(fmt,[age]);
end;


procedure spacebuttons(buts : array of Tcontrol);
{ evenly space these buttons horizontally in the width of their parent
  Only take into account visible buttons.  This means that you can
  set the visibility of buttons prior to calling and have only those
  showing laid out evenly

}
var
  bw,margin,i,x,sparew,nobuts : integer;
  p : tcontrol;
begin
  // get parent
  p := buts[low(buts)].parent;

  // total width of buttons
  bw := 0;
  for i := low(buts) to high(buts) do if buts[i].visible then bw := bw + buts[i].width;

  // space between them
  sparew := p.clientwidth - bw;
  nobuts := 1+high(buts)-low(buts);
  margin := sparew div (nobuts+1);

  x := margin;
  for i := low(buts) to high(buts) do begin
    if buts[i].visible then begin
      buts[i].left := x;
      x := x + buts[i].width+margin;
    end;
  end;
end;





function GetTempDirectory:string;
{ return the location of the temporary directory }
var
  pTemp : pchar;
  TempPath : string;
begin
  pTemp  := StrAlloc(MAX_PATH);
  if GetTempPath(MAX_PATH, pTemp) = 0 then begin
    temppath := 'C:\temp\';   // No temp path!!
  end else begin
    TempPath := String(pTemp);
  end;
  StrDispose(pTemp);
  result := TempPath;
end;




function AlphaOrd(const anOrdinal:integer):string;
{ convert an ordinal into 0,1,2.... as character for compact
  storage in a database}
begin
  result := chr(48+anOrdinal);
end;

function OrdAlpha(const aCharacter:string):integer;
{ decode character "0" --> 0  "1" --> 1 in database
  see AlphaOrd }
begin
  result := ord(acharacter[1])-48;
end;

function  MinsTohhmm(const mins:integer):string;
{ return a nice string for time }
begin
  result := format('%2d:%2.2d',[mins div 60, mins mod 60]);
end;

function  hhmmToMins(const hhmm:string):integer;
{ interpret <hours>:<minutes>
  Blank and ':' --> 0
  <hours> and <minutes> do not need leading zeroes }
var
  h,m : string;
  hi,mi : integer;
begin
  m := hhmm;
  h := chop(m,':');
  hi := strtointdef(h,0);
  mi := strtointdef(m,0);
  if (hi < 0) or (mi<0) then begin
    result := 0;
  end else begin
    result := (60*hi)+mi;
  end;
end;

function SizeOfFile(const fname:string):integer;
{ how large is the file (without opening it) in bytes
  Not found returns 0
}
var
  sr : Tsearchrec;
begin
  if FindFirst(fname, faAnyFile, sr) <> 0 then begin
    result := 0;  // some problem
  end else begin
    result := sr.size;
  end;
  sysutils.Findclose(sr);
end;



function SimpleHash(const srce:string):string;
{ do a simple hash to return a 4 character string
  THIS IS NOT SECURE

  Test results :
    5 character test strings.  perfect p(clash)=1:9.1 million
                               actual          =4:20  million = 1:5 million = quite good
  }
var
  m,i,k,j,p,ls : integer;
  s : string;
  c : char;
  b : byte;
  x : array [0..5] of integer;
begin
  if srce = '' then begin
    result := 'XXXX';
    exit;
  end;

  ls := length(srce);
  m := ls;
  k := ls;
  for i := 1 to ls do begin
    b := ord(srce[i]);
    k := k + b;
    m := abs((m * (b-i)) mod 3456);
  end;

  while length(s)<400 do s := s + srce;
  for i := 0 to 5 do begin
    x[i] := (1234*ls*(i+3));
    x[i] := x[i] + (k mod (i+13));
    x[i] := x[i] + (m mod (i+19));
  end;

  for i := 1 to length(s) do begin
    c := s[i];
    b := ord(c);
    j := (b*i) mod 17;
    k := i mod 4;
    x[k] := x[k]+j;

    if ((ls+1) mod 20) < 4 then begin  // perturb for short strings but also elsewhere
      j := (b+i) mod 17;
      x[k+1] := x[k+1]+j;
    end;

    if (i mod ls) = 0 then begin
      x[1] := x[1]+i;
      x[2] := x[2]-j
    end;

    if x[k]>999 then x[k] := x[k]-777;

    for m := 1 to 2 do begin
      j := j + 1;
      p := pos(chr(b+1),s);
      if p>0 then begin
        x[3+m] := x[3+m]+((i*(p+j)) mod 17);
        if x[3+m]>999 then x[3+m] := x[3+m] mod 457;
      end;
    end;
  end;

  x[0] := x[0]+x[4];
  x[1] := x[1]-x[4];
  x[2] := x[2]+x[5];
  x[3] := x[3]-x[5];

  result := '';
  for i := 0 to 3 do begin
    while x[i]<0 do x[i] := x[i]+555;
    x[i] := x[i] mod 123;
    b := x[i] mod 55;
    result := result + chr(b+65);
  end;

end;


function LoadTextFile(const fname:string):string;
{ returns a string which is the complete contents.
  If the file doesn't exist then return an empty string
  Max size of file = 32K
}
var
  s : tstringlist;
begin
  if not fileexists(fname) then begin
    result := '';
  end else begin
    s := tstringlist.create;
    try
      s.loadfromfile(fname);
      result := s.text;
    finally
      s.free;
    end;
  end;
end;


procedure SaveTextFile(const fname,txt:string);
{ save the text string to a file in one go
  Max size of file = 32K
}
var
  s : tstringlist;
begin
  s := tstringlist.create;
  try
    s.text := txt;
    s.savetofile(fname);
  finally
    s.free;
  end;
end;



function FontToString(const F:Tfont):string;
{ this returns a string version of the font
  format : Name|size|colour|style  where style is b,i, or bi or nothing
  see StringToFont()
}
begin
  result := '';
  if not assigned(f) then exit;
  result := f.name+'|'+inttostr(f.size)+'|'+colortostring(f.color)+'|';
  if fsbold in f.style then result := result + 'b';
  if fsitalic in f.style then result := result + 'i';
end;

procedure StringToFont(const s:string; var f:tfont);
{ This returns a font built from the string.
  If f is nil then it will be created
  If all or part of string is missing defaults will be used
  See FontToString()
}
var
  v,t : string;
begin
  if not assigned(f) then f:=tfont.create;
  t := s;
  v := chop(t,'|');
  if v = '' then f.name := 'Arial' else f.name := v;
  v := chop(t,'|');
  if v = '' then f.size := 10 else f.size := strtointdef(v,10);
  v := chop(t,'|');
  if v = '' then f.color := clBlack else f.color := stringtocolor(v);
  v := chop(t,'|');
  f.style := [];
  if v <> '' then begin
    if pos('b',v)<>0 then f.style := f.style + [fsbold];
    if pos('i',v)<>0 then f.style := f.style + [fsitalic];
  end;
end;



procedure DrawGridFlag(can:tcanvas;const rect:trect;const Shape:TGridFlagtype;
                       const ShapeClr,TxtClr:tcolor;const text:string);
{ this is intended for drawing flags in dbgrids although it is generic
  for example in TDbGrid.DrawColumnCell event }
var
  x,y : integer;
begin
  with can do begin
    // --- draw the shape ---
    brush.color := ShapeClr;
    case shape of
    stcircle : ellipse(rect.left,rect.top,rect.right,rect.bottom);
    stSquare : fillrect(rect);
    stNone   : ;
    end;

    // --- draw the text (letter) ---
    font.color := TxtClr;
    font.style := [fsbold];
    x := ((rect.right-rect.left)-textwidth(text)) div 2;
    y := ((rect.bottom-rect.top)-textheight(text)) div 2;
    TextOut(Rect.Left+x, Rect.Top+y,text);

    // --- tidy up ---
    brush.color := clwindow;
    font.color := clBlack;
    font.style := [];
  end;
end;


procedure DrawFileIcon(const filename:string; can:tcanvas; const x,y:integer);
{ get icon (associated with) file and paint it on the canvas }
var
  IconIndex : word;
  h : hIcon;
begin
  IconIndex := 0;
  h := ExtractAssociatedIcon(hInstance,pchar(filename),IconINdex);
  DrawIcon(can.Handle,x,y,h);
  //@@@ free handle
end;

(*function GetIconForFile(const filename:string):ticon;
{ returns an icon which represents the file - typically by association

  resources need careful handling:-
  | var
  |   I : ticon;
  | begin
  |   I := GetIconForFile('foobar.htm');   // get the icon
  |   pic.picture.icon.assign(I);          // use it
  |   I.free;                              // free the icon and windows resource behind it
  | end;

  filename must be complete including eg c:... (see delphi function GetCurrentDir)

}
var
  wix : word;
  fn : array[0..255] of char;
begin
  wix := 0;
  result := TIcon.create;
  fillchar(fn,sizeof(fn),#0);
  strpcopy(fn,filename);
  result.handle := ExtractAssociatedIcon(application.handle,@fn,wix);
end;
*)


function GetNetUserName: string;
var
  pcUser: PChar;
  dwUSize: DWORD;
begin
  dwUSize := 21;              // user name can be up to 20 characters
  GetMem(pcUser, dwUSize);    // allocate memory for the string
  try
    if NO_ERROR = WNetGetUser(0, pcUser, dwUSize)
      then Result := pcUser;
  finally
    FreeMem(pcUser);
  end;
end;



function NameOfUser:String;
{ return the name of the user }
var
  pcUser: PChar;
  dwUSize: DWORD;
begin
  result := '';
  dwUSize := 21;              // user name can be up to 20 characters
  GetMem(pcUser, dwUSize);    // allocate memory for the string
  try
    if NO_ERROR = WNetGetUser(0, pcUser, dwUSize)
      then result := pcUser;
  finally
    FreeMem(pcUser);
  end;
end;


function NameOfComputer:String;
{ return the name of the computer }
var
  pcComputer: PChar;
  iSize: longword;
begin
  result := '';
  pcComputer := StrAlloc(MAX_COMPUTERNAME_LENGTH + 1);
  try
    iSize := MAX_COMPUTERNAME_LENGTH + 1;
    Windows.GetComputerName(pcCOmputer, iSize);
    result := StrPas(pcComputer);
  finally
    StrDispose(pcComputer);
  end;

end;

Function ValidateDateStr(const ds:string;var day:ttinydate;const early,late:Ttinydate):boolean;
{ ds is typically an input from an edit box
  day is the result
  early and late are inclusive limits
  Date must be real if early/late are real
}
begin
  day := texttotinydate(ds);
  result := tdisreal(day);
  if result then begin
    result := (early >= day) and (day <= late);
  end else begin
    result := ((day=early) or (day=late));
  end;
end;


end.
